/* LANGUAGE:    C        VAX VMS COMPILER VERSION 2.0-003


 PACKAGE NAME:          LDEF.H

 PACKAGE ROUTINES:      

 PACKAGE FUNCTION:      Symbolic constants definitions

 PACKAGE AUTHOR(s):     Daniela Magnani

 PACKAGE CREATION DATE: 21/08/1986

 PACKAGE MODIFICATIONS: 
            26/01/89 (L.Croce): START/STOP defines modified, N_R removed,
                                TL_... defines added.

**********************************************************************/



# include "portab.h"

#ifndef TL_NAME
#define TL_NAME "MOZART Linker"
#endif
#ifndef TL_REL
#define TL_REL  "3.0"
#endif
#ifndef TL_CREL
#define TL_CREL  "3.0"
#endif
#ifndef TL_DATE
#define TL_DATE "14 Feb 1989"
#endif
#ifndef TL_CPU
#define TL_CPU  "<no name>"
#endif

# define FALSE          0
# define TRUE           (! FALSE)

# ifndef NULL
# define NULL           0
# endif

# define UNDEFINED      (-1)

# define MAX_UNSIGNED   (unsigned) 0xffffffff   /* 4294967295 */
# define MAX_CHR	255
# define NULL_NAME      ""

# define LK_NAME        TL_NAME
# define LK_DATE	TL_DATE

# define C_LREL         TL_REL  /* linker release   */
# define C_CREL		TL_CREL /* compiler release */

# define DIM_UNHASH     211     /* units hash table dimension */
# define DIM_DELHASH    211     /* delays table dimension */
# define DIM_CONSTHASH  211     /* constants'table dimension */
# define DIM_INITHASH   211     /* initialization table dimension */
# define DIM_MODCHASH   211     /* modules C table dimension */
# define DIM_FUNCHASH   211     /* functions C table dimension */

# define DIM_LEVEL      10      /* maximum nesting level */

# define NAMELENGTH	31	/* symbols'max length */
# define CONSTLENGTH    256     /* constant max length */
# define PATHLENGTH     (((DIM_LEVEL+1) * (NAMELENGTH + 1))+1)
				/* path name max length */

# define FILEDEF        255     /* file name max length */
# define DIRDEF         235     /* Directory or Library name max length */
# define MAX_DIR        16      /* Maximum amount of directories and libraries*/

# define DIR		'd'
# define DIRL		'h'
# define LIBD		'l'
# define EXCD		'e'

# define MAX_TOP	0x7fffffff   /* (2**31) maximum amount of topol. elem.*/
# define MAX_SHORTINT   ((1<<24)-1)
# define MAX_DELAY      65536   /* (2**16) maximum amount of delays */
# define MAX_FAN        64000   /* maximum fanout */
# define MAX_LEV        255     /* maximum simulation level */

# define MAX_LINES      62      /* number of printable lines/page */
# define DIM_STACK	256	/* loop stack dimension */
# define SEP_STR        "/"     /* path name separator character */

# define DRC_NM         "**"    /* symbol starting a name for DRC */
# define DRC_LN         ";"     /* symbol to be inserted before the last 
				   interface symbol for DRC */
# define DRC_KW         "CCT"   /* keyword starting the file for DRC */

/* unit types */

# define U_UNIT		0
# define U_PROCESS	1
# define U_COMPONENT	2

/* transistor types */

# define _DEPLETION     0
# define _NCHANNEL      1
# define _PCHANNEL      2

/* transistor pin types */

# define DRAIN_PIN      0
# define GATE_PIN       1
# define SOURCE_PIN     2

/* symbol types */

# define NOD            0	/* Node */
# define WIR            1	/* Wire */
# define REG            2	/* Register */
# define CONST          3	/* Constant */
# define TRAN           4	/* Transistor */
# define GAT            5	/* Gate */
# define MEM            6	/* Memory */
# define PROC		7	/* Process */
# define RT_AS          8	/* RT_Assignement */
# define RT_CN          9	/* RT_Condition */
# define RT_CNT		10	/* RT_Condition Control */
# define RT_LD          11	/* RT_Load */
# define AS_TR          12	/* AS_Trigger */
# define BIT_EX         13	/* Bit_Extraction */
# define AS_TR_CN       14	/* AS_Trigger Control */
# define LOCV           15	/* Local Variable */
# define USE            16	/* Unit Instantation */
# define DEF            17	/* Unit Definition */


/* descriptor types */

# define INTERN         0
# define PI             1
# define PO             2
# define PB             3
# define DUMMY          4
# define ILLEGAL        5

/* Element's function flag*/

# define F_NO_FUNCTION	0
# define F_CONTROL	8
# define F_TRIG_1	2
# define F_TRIG_0	1

/* constant's types */

# define C_WIRE		0
# define C_INT		1
# define C_REAL		2
# define C_CHAR		3
/* local to linker */
# define D_CONST	4

/* gate's types */

# define BUF            4
# define TGP            35
# define TGN            36
# define MTGP           37
# define MTGN           38
# define BTRI           39
# define BMOS           40
# define BUP            41
# define BDOWN          42
# define AND_TRI	6
# define INV_OE		29

# define FIRST_FF	43
# define LAST_FF	69

/* connection to RT_AS/CN/LD */

# define C_TR_0         2
# define C_TR_1         3
# define C_DATA         4
# define C_AS_TR	5
# define C_CONTROL	6

/* computational appendix types */

# define STOP_C		0
# define OPERATOR       1
# define OPERAND        2
# define IMMEDIATE	3
# define CALL           4
# define TIME		5
# define GLOBAL_OP      8
# define OP_EXEC       11

# define STOP_AS        0
# define STOP_EN        1
# define STOP_TRIG_1    2
# define STOP_TRIG_2    3
# define STOP_EXIT_DIS  4

/* computational appendix : operator codes */

# define OFFS		43    /* = P_TRIG_0 - 2 */

# define M_ADD		56
# define M_MPY		58

# define _NOP		63

/* attributes' boundaries */

# define DELAY_MIN      0
# define DELAY_MAX      1073741823 /* (2**30)-1 maximum delay value */

/* default values */

# define DEF_STR        1
# define DEF_SIZE       0
# define DEF_DEL        0

/* static block values */

# define STRAN          10
# define SDEF           9
# define SGATE          7

/*                */
# define C              udesc.d_carr
# define T              udesc.d_tran
# define G              udesc.d_gate
# define U              udesc.d_umod
# define D              udesc.d_dmod
# define O              udesc.d_rtcn
# define A              udesc.d_rtas
# define I              udesc.d_const
# define M              udesc.d_mem
# define S              udesc.d_astr
# define P              udesc.d_proc

# define IW             udesc.d_const.desconst.d_wconst
# define ID             udesc.d_const.desconst.d_dconst
# define IC             udesc.d_const.desconst.d_cconst

# define H_S            h_exe.p_stat
# define H_E            h_exe.p_ev_stat
# define VDD            h_exe.vdd
# define GND            h_exe.gnd

# define U_H            u->head
# define U_P            u->par_table
# define U_S            u->head->stat_unit
# define U_T            u->head->symb_unit

# define CT             conn.time
# define CL             conn.call
# define CC             conn.conn

/* zero_delay_loop visit flag  */
# define STRONG         3 
# define WEAK           2   

/* compiler output files extension */
# define TOP_OBJ        ".deo"

/* linker output files extension */
# define TOP_EXE        ".dee"
# define MAP_EXE        ".dem"
# define NET_EXE        ".exp"

/* library file extension */
# define LIB_EXT	".lib"

/* CONN list types        */

# define FANIN          1
# define FANOUT         2
# define LCONN          3 
# define CODE           4
# define AT_OUT         5

/* delay types */

# define DEL_IMM	0
# define DEL_CON	1

# define MEM_OV         bug("Dynamic memory overflow")
# define DEO_ERR        bug2("Error reading file ", fobj)
# define NAME_ERR(A)    fatal2("Name too long", A)
# define PATH_ERR       fatal("Path name too long")
# define STOP           printf("\n*** %s ver. %s  %s (%s) - stopped *** \n\n", \
                               TL_NAME, TL_REL, TL_DATE, TL_CPU)
# define START          printf("\n*** %s ver. %s  %s (%s) - started *** \n\n", \
                               TL_NAME, TL_REL, TL_DATE, TL_CPU)
# define LIN_ER         fatal \
   ("usage: linker <filename> [-v] [-z] [-a] [-n] [-d<directory>] [-h<library>]\
[-l<library>] [-e<library>]");

# ifdef max
# undef max
# endif
# define MAX(A, B)      ((A) > (B) ? (A) : (B))

# ifdef min
# undef min
# endif
# define MIN(A, B)      ((A) < (B) ? (A) : (B))

# define LOOP(A)        { \
                             if (!ch_delay) signal_loop(A, "0-Delay loop(s)"); \
                             c_del_loop++; \
                        }
# define ALOOP(A)       { \
				if (atpg_flag) signal_loop(A, "ATPG loop(s)"); \
                                c_atpg_loop++; \
                        }
# ifdef tolower 
# undef tolower
# endif

# define TOLOWER(X)	((X >= 'A' && X <= 'Z') ? (X + 'a' - 'A') : (X))

# ifdef toupper
# undef toupper
# endif

# define TOUPPER(X)	((X >= 'a' && X <= 'z') ? (X + 'A' - 'a') : (X))










/* file specifications values MOZART & VMS */

# define IDLENGTH	31      /* MOZART symbols'max length */
# define EXTLENGTH      4	/* MOZART file extension length */
# define PLENGTH	321	/* path max length VMS */
# define FILELENGTH	364	/* filename max length PLENGTH + 39
				   + EXTLENGTH */
# define RFLENGTH	360	/* PLENGTH + FILELENGTH */

/* values for flags */

# define UPDATE		"r+"
# define READ		"r"

/* macros */

# define POS_ERR	bug("Illegal file positioning\n")


/* inserted since 01 jul 1988 */

/* allocation parameters */
# define NCON	512	/* connectivity elements composing a block */
# define DIMCON	sizeof(struct struct_conn)

# define NSTAT	512	/* static elements composing a block */
# define DIMSTAT sizeof(struct struct_ld_static)

