/* LANGUAGE:    C        VAX VMS COMPILER VERSION 2.0-003


 PACKAGE NAME:          LLINK

 PACKAGE ROUTINES:      link_step()
                        cre_p_table()
                        insert_lev()
                        hash()
                        search_u()
                        in_hash()
                        cre_in_node()
                        make_param()
                        elim_unit()
                        ins_fa_son()
                        levelizing()
                        merge_step()
                        top_val()
                        copy_un()
                        inc_l()
                        param_mapping()
                        chng_tb()
                        s_corr()
                        mapping()
			add_del()
			uni_delay()
                        d_tst()
                        f_map()
                        ttype()
                        chng_conn()
                        chng_conn_const()
                        mod_conn()
                        mod_conn_const()
                        compact()
                        const_insearch()
                        modif()
			elim_unit_int()
			search_mtb()
			sig_map()
			disconn()
			chng_conn_bex()
			copy_exp()
			unic_delay()
			const_int()
			ret_ptr_exp()
			copy_del()
			copy_exp_del()
			search_del()
			create_new_el_not_con()

 PACKAGE FUNCTION:      Perform link step

 PACKAGE AUTHOR(s):     Daniela Magnani

 PACKAGE CREATION DATE: 21/08/1986

**********************************************************************/

# include <stdio.h>
# include "ldef.h"
# include "lstruct.h"
# include <math.h>

/***************************************************************************/
/*                                                                         */
/*                          VARIABLES DECLARATION                          */
/*                                                                         */
/***************************************************************************/

UNIT_PTR        unit_hash[DIM_UNHASH];  /* units hash table */
UNIT_PTR        p_level[DIM_LEVEL];     /* levels start pointers */
IN_T_PTR        in_tree = NULL;         /* instantiations tree */
long            max_level = 0;          /* max units level */
unsigned char	vdd_ext = FALSE;
unsigned char	gnd_ext = FALSE;

static UNIT_PTR         u;
static HCONST_PTR       const_headhash[DIM_CONSTHASH];/* constants hash table */
static long             *corr;
static long             *aux;
static unsigned char    new_vdd;
static unsigned char    new_gnd;
static unsigned long    par_ind;                /* parameter table index */
static unsigned long    i_i;                    /* instantiations tree index */
static unsigned long    inst_counter;           /* instantiations counter */
static unsigned long    def_counter;            /* definitions counter */
static INT_GT_PTR	l_gate = NULL;
static unsigned long	count_wri = 0;
static unsigned int	free_el;

STAT_PTR	*deb;


/*************************************************************************

   ROUTINE:     link_step

   FUNCTION:    main of the link step

   AUTHOR(s):   Daniela Magnani

   DATE:        21/08/1986

   NOTES: 

   METHOD: 

**********************************************************************/

link_step()

{
/* external variables */

        extern EHEADER          h_exe;
        extern unsigned long    n_enqueue_l;
	extern unsigned char	net_flag;
	extern unsigned char	lib_flag;
	extern IN_ST		par_des[];
	extern unsigned long	dir_number;

	extern unsigned long	u_n_bitpi,
				u_n_bitpo,
				u_n_bitpb,
				u_n_const,
				u_n_tran,
				u_n_gate,
				u_n_rtas,
				u_n_rtcn,
				u_n_mem,
				u_n_delay,
				u_n_spipb,
				u_n_symr,
				in_po;
	extern unsigned char	u_f_sim,
				u_f_case;
	extern ODELAY_PTR	*del_con_tab;
	extern unsigned long	n_del_con;

/* external functions */

        char            *alloca();
        OHEADER_PTR     load_unit();
        UNIT_PTR        search_u();
        UNIT_PTR        in_hash();
        FIFOU_PTR       dequeue_u();
	INTF_PTR	cre_intf();
        long            *cre_p_table();
	unsigned long	check_gate();
	char		close_lib();
	STAT_EV_PTR	*new_ev_top_el();

/* local variables */

        FIFOU_PTR       p_u;
        INTF_PTR        p_intf;
        unsigned long   i;
        long            level;
	unsigned long	p_c;

/* code */

/* STEP 0 : initialization                                              */

        for (i = 0; i < DIM_LEVEL; i++) p_level[i] = NULL;
        for (i = 0; i < DIM_UNHASH; i++) unit_hash[i] = NULL;
        for (i = 0; i < DIM_CONSTHASH; i++) const_headhash[i] = NULL;
        corr = NULL;
        max_level = 0;
        inst_counter = 1;
        def_counter = 0;
        i_i = 0;

/* STEP 1 : units load                                                  */

        while ((p_u = dequeue_u()) != NULL)
        {
           if ((u = search_u(p_u->name)) == NULL)
           {
                /* unit definition not found in units hash table */
                def_counter++;
                u = in_hash(p_u->name);
                U_H = load_unit(p_u->name, &u->dir);
		u->n_const_del = n_del_con;
		u->del_con_tab = del_con_tab;

                h_exe.f_sim &= u_f_sim;
		if (def_counter == 1)
		{
		        h_exe.name = u->name;
			h_exe.f_case = u_f_case;
		        h_exe.n_pi = U_H->n_pi;
		        h_exe.n_bitpi = u_n_bitpi;
		        h_exe.n_po = U_H->n_po;
		        h_exe.n_bitpo = u_n_bitpo;
		        h_exe.n_pb = U_H->n_pb;
		        h_exe.n_bitpb = u_n_bitpb;
			h_exe.n_gate = u_n_gate;
		}

		else
		{
			if (h_exe.f_case != u_f_case)
			   fatal2("Illegal case type in unit: ", p_u->name);
			h_exe.n_gate += u_n_gate;
		}
			
		h_exe.time_unit = MIN(h_exe.time_unit, U_H->time_unit);

		/* control for DRC */
		if (net_flag)
		{
		    if (u->dir == MAX_UNSIGNED || par_des[u->dir].type == DIR
			|| par_des[u->dir].type == DIRL)
		    /* check on unit not Gate Array */
		    {
			if ((u_n_tran > 0) || (u_n_gate > 0) ||
			   (u_n_rtas > 0) || (u_n_rtcn > 0) ||
			   (u_n_mem > 0) || (u_n_const > 0))
			{
				h_exe.f_drc = FALSE;
				warn2("unit is not valid for DRC", p_u->name);
			}
			else
			{
				if (U_H->vdd != MAX_UNSIGNED) vdd_ext = TRUE;
				if (U_H->gnd != MAX_UNSIGNED) gnd_ext = TRUE;
			}
		    }
		    else
                    {
			h_exe.n_gtar++;
		    }
		}
                /* PI PO PB & interface tables creation */
                /* evaluate the start index for PI */
                if (U_H->n_pi > 0) u->pi_table = cre_p_table(U_H->n_pi, &in_po);
                if (U_H->n_po > 0) u->po_table = cre_p_table(U_H->n_po, &in_po);
                if (U_H->n_pb > 0) u->pb_table = cre_p_table(U_H->n_pb, &in_po);

		/* create interface table */
                if (def_counter > 1 && u_n_spipb > 0)
                {
                	u->n_intf = u_n_spipb;
			u->intf_table = p_intf = 
                                (INTF_PTR) alloca(u->n_intf * sizeof(*p_intf));
			p_c = 0;

			if (u->po_table != NULL) 
			p_intf = cre_intf(u->po_table, U_H->n_po, p_intf, &p_c);
			if (u->pi_table != NULL) 
			p_intf = cre_intf(u->pi_table, U_H->n_pi, p_intf, &p_c);
			if (u->pb_table != NULL) 
			p_intf = cre_intf(u->pb_table, U_H->n_pb, p_intf, &p_c);
                }

                if (U_H->list_def == NULL)
                {
                        /* unit without unit calls */
                        u->level = 0;
                        /* enqueue into level assigned units list */
                        enqueue_l(u->name, u);
                        /* link to level 0 list */
                        insert_lev(u->level);
                }
                else
                {
                        u->level = UNDEFINED;
                        /* parameter table creation */
                        make_param();
                }
           }
           /* update the father list of the unit under examination */
           ins_fa_son(&u->father_list, p_u->father_name);

	   release(p_u, sizeof(*p_u));
        }

/* STEP 2 : units levelizing & instantiations tree generation           */

	/* libraries close */
	if (lib_flag)
	{
		for (i = 0; i < dir_number; i++)
		{
			if (par_des[i].lib != NULL) close_lib(par_des[i].lib);
		}
	}

        if (def_counter > 1) levelizing();

        /* map file generation */
        cre_map();

        if (n_enqueue_l != def_counter) fatal("loop in unit calls");

        in_tree_gen();

/* STEP 3 : bottom up integration                               */

        for (level = 1; level <= max_level; level++)
        {
                /* scan the units with the same level */
                for (u = p_level[level]; u != NULL; u = u->level_next)
                {
                        merge_step();
                        param_mapping();
			elim_unit_int();
                }
        }

	/* signal the amount of illegal write on output signal */
	if (count_wri > 0) warn("output signal(s) used as inout");

/* STEP 4 : integrated structure generation                     */

        u = p_level[max_level];
        if ((h_exe.n_gate > 0 && check_gate() > 0) || def_counter != 1) compact();
	if (u->n_const_del > 0 || u->n_const_del_exp > 0) mod_delay();

	h_exe.n_gate = 0;
        h_exe.warn_cnt = U_H->warn_cnt;
        h_exe.n_top = U_H->n_top;
	if (h_exe.n_top > MAX_TOP) fatal("Too many topological elements"); 
        VDD = U_H->vdd;
        GND = U_H->gnd;
        h_exe.n_def = def_counter;
        h_exe.n_inst = inst_counter;
        h_exe.p_stat = U_S;
	h_exe.p_ev_stat = new_ev_top_el(h_exe.n_top);
}


/*************************************************************************

   ROUTINE:     cre_intf

   FUNCTION:    

   AUTHOR(s):   Daniela Magnani

   DATE:        04/05/1987

   NOTES:       Interface element may be only a carrier (name pointed by the 
		field s_tab) or a gate (name pointed by the fields s_tab and 
		s_lst).

   METHOD: 

**********************************************************************/

INTF_PTR cre_intf(list, n_el, st_p, cc)
long *list;
unsigned long n_el;
INTF_PTR st_p;
long *cc;

{

/* local variables */

	unsigned long	i;

/* code */

	while (n_el-- > 0)
	{
		i = *list++;
		st_p->addr = i;
		st_p->par_n = (short)(*cc);
		st_p->sort_link = NULL;

		U_S[i]->s_tab->st_el = MAX_UNSIGNED;
  		st_p->name = U_S[i]->s_tab->el_name;
		st_p++;

		if (U_S[i]->code == GAT)
		{
			st_p->addr = i;
			st_p->par_n = (short)(*cc);
			st_p->sort_link = NULL;

			U_S[i]->G.s_lst->st_el = MAX_UNSIGNED;
                       	st_p->name = U_S[i]->G.s_lst->el_name;
			st_p++;
		}
		(*cc)++;
	}
	return(st_p);
}


/*************************************************************************

   ROUTINE:     cre_p_table

   FUNCTION:    create a list containing n_el consecutive values
                Returns the list start pointer.

   AUTHOR(s):   Daniela Magnani

   DATE:        17/09/1986

   NOTES:       

   METHOD: 

**********************************************************************/

long *cre_p_table(n_el, st_ad)
unsigned long n_el;
long *st_ad;

{
/* external functions */

        char    *alloca();

/* local variables */
        
        long    *po;
        long    *table;
        
/* code */
        
        table = po = (long*) alloca(n_el * sizeof(long));

        while (n_el-- > 0)
        {
                *po++ = (*st_ad)++;
        }
        return(table);
}


/*************************************************************************

   ROUTINE:     insert_lev

   FUNCTION:    insert an unit into the list corresponding to the level
                given as parameter.
                Evaluate max_level as maximum between the old max_level
                and the level given as parameter.

   AUTHOR(s):   Daniela Magnani

   DATE:        21/08/1986

   NOTES:       

   METHOD:      LIFO

**********************************************************************/

insert_lev(level)
long level;

{
/* code */

        u->level_next = p_level[level];
        p_level[level] = u;
        max_level = MAX(max_level, level);
}


/*************************************************************************

   ROUTINE:     hash

   FUNCTION:    Return hash address.

   AUTHOR(s):   Daniela Magnani

   DATE:        21/08/1986

   NOTES: 

   METHOD: 

**********************************************************************/

long hash(s)
char *s;

{
/* local variables */

	static long    hashvalue;


/* code */

        for (hashvalue = 0; *s; hashvalue += *s++);
        return(hashvalue);
}


/*************************************************************************

   ROUTINE:     search_u

   FUNCTION:    Search an unit name into units hash table.
                Return the unit pointer if the search was successfull.
                Otherwise it returns NULL.

   AUTHOR(s):   Daniela Magnani

   DATE:        21/08/1986

   NOTES: 

   METHOD: 

**********************************************************************/

UNIT_PTR search_u(s)
char *s;

{
/* external functions */

        int     strcmp();
	long	hash();

/* local variables */

        UNIT_PTR        p;

/* code */

        for (p = unit_hash[hash(s) % DIM_UNHASH]; 
                p != NULL && strcmp(s, p->name) != 0; p = p->hash_next);
        return (p);
}


/*************************************************************************

   ROUTINE:     in_hash

   FUNCTION:    Insert an unit into the units hash table

   AUTHOR(s):   Daniela Magnani

   DATE:        21/08/1986

   NOTES: 

   METHOD: 

**********************************************************************/

UNIT_PTR in_hash(s)
char *s;

{
/* external functions */

        char    *alloca();
	long	hash();

/* local variables */

	static UNIT_PTR        p;
        static long            hashval;

/* code */
        
        /* new hash element creation  & initialization */
        p = (UNIT_PTR) alloca(sizeof(*p));

        p->name = s;
        p->head = NULL;
        p->level = UNDEFINED;
        p->level_next = NULL;
        p->son_def_list = NULL;
        p->father_list = NULL;
        p->pi_table = NULL;
        p->po_table = NULL;
        p->pb_table = NULL;
        p->n_intf = 0;
        p->intf_table = NULL;
        p->intf_sort_table = NULL;
        p->par_table = NULL;
        p->in_lst = NULL;
        p->flag_res = FALSE;
        p->dir = MAX_UNSIGNED;
	p->exp_list = NULL;
	p->exp_el = 0;
	p->del_con_tab = NULL;
	p->del_con_exp_tab = NULL;
	p->n_const_del = 0;
	p->n_const_del_exp = 0;

        /* insertion (LIFO) in hash list */
        p->hash_next = unit_hash[hashval = hash(s) % DIM_UNHASH];
        unit_hash[hashval] = p;
        return(p);
}


/*************************************************************************

   ROUTINE:     enqueue_n

   FUNCTION:    #

   AUTHOR(s):   Daniela Magnani

   DATE:        10/09/1986

   NOTES: 

   METHOD: 

**********************************************************************/

enqueue_n(u, node)
UNIT_PTR u;
unsigned long node;

{
/* external functions */

        char    *alloca();

/* local variables*/

        IN_N_PTR        p;

/* code */
        
        p = (IN_N_PTR) alloca(sizeof(*p));

        /* new element creation */
        p->node = node;

        /* insertion (LIFO) in nodes list */
        p->pun = u->in_lst;
        u->in_lst = p;
}


/*************************************************************************

   ROUTINE:     in_tree_gen

   FUNCTION:    Create the instantiations tree.

   AUTHOR(s):   Daniela Magnani

   DATE:        18/09/1986

   NOTES: 

   METHOD:      

**********************************************************************/

in_tree_gen()

{
/* external functions */

        char            *alloca();
        IN_L_PTR        dequeue_in();

/* local variables */

        IN_L_PTR        p_i;

/* code */

        /* instantiations number evaluation */
        if (def_counter > 1) count_inst();

        u = p_level[max_level];

        /* Instantiations tree generation */
        in_tree = (IN_T_PTR) alloca(inst_counter * sizeof(*in_tree));
        
        /* create node for MAIN unit */
        in_tree[i_i].in_name = u->name;
        in_tree[i_i].def_name = in_tree[i_i].in_name;
        in_tree[i_i].st_addr = 0;
        in_tree[i_i].end_addr = U_H->n_top - 1;
        in_tree[i_i].intf_dim = 0;
        in_tree[i_i].intf_table = NULL;
        in_tree[i_i].father = MAX_UNSIGNED;
        in_tree[i_i].brother = MAX_UNSIGNED;
        in_tree[i_i].child = MAX_UNSIGNED;
        in_tree[i_i].un_addr = u;

        enqueue_n(u, i_i);

        /* MAIN expansion if it calls some units */
        if (U_H->n_umod > 0)
        {
                enqueue_in(i_i, 0, u);
                while((p_i = dequeue_in()) != NULL)
                {
                        cre_in_node(p_i->node, p_i->unit);
			release(p_i, sizeof(*p_i));
                }
        }
}


/*************************************************************************

   ROUTINE:     count_inst

   FUNCTION:    conteggia il numero complessivo di istanziazioni di unit

                associa a ogni elemento della param_table della unit u 
                un pointer al corrispondente elemento della unit hash table


   AUTHOR(s):   Daniela Magnani

   DATE:        08/09/1986

   NOTES: 

   METHOD:      gli elementi della param_table sono ordinati per nome unit
                definition - eseguo quindi ricerca hash nella unit hash table 
                solo quando cambia nome

**********************************************************************/

count_inst()

{
/* external functions */

        UNIT_PTR        search_u();
        char            *strcpy();
	int		strcmp();
	int		strlen();

/* local variables */

        char            act_name[NAMELENGTH + 1];
        unsigned long   i;
        UNIT_PTR        act_ptr = NULL;
        long            level;

/* code */

        strcpy(act_name ,NULL_NAME);
        for (level = 1; level <= max_level; level++)
        {
                /* scan the units with the same level */
                for (u = p_level[level]; u != NULL; u = u->level_next)
                {
                        for (i = 0; i < U_H->n_umod; i++)
                        {
                           if (strcmp(act_name, U_P[i].def_name) != 0)
                           {
                                /* ricerca hash e modifica degli attuali valori
                                nome - pointer */
                                act_ptr = search_u(U_P[i].def_name);
                                if (strlen(act_ptr->name) >NAMELENGTH) 
                                                NAME_ERR(act_ptr->name);
                                strcpy(act_name ,act_ptr->name);
                           }

                           U_H->n_inst += act_ptr->head->n_inst;
                           /* memorizzo nella param_table il puntatore alla unit
                           definition per velocizzare step successivi */
                           U_P[i].un_addr = act_ptr;
                        }
                }
        }

        u = p_level[max_level];
        inst_counter += U_H->n_inst;
}


/*************************************************************************

   ROUTINE:     cre_in_node

   FUNCTION:    Create the children of a node of the instantiation tree.

   AUTHOR(s):   Daniela Magnani

   DATE:        21/08/1986

   NOTES:       Instantiations tree is stored into an array.

   METHOD:      Create all the children of the input parameter node
                scanning its units calls table.

**********************************************************************/

cre_in_node(node, unit)
unsigned long node;     /* index of the node to be expanded */
UNIT_PTR unit;  /* unit definition crresponding to the node */

{

/* local variables */

        unsigned long   i;
        unsigned long   brother;
                
/* code */

        brother = MAX_UNSIGNED;
        
        /* set pointer from node to its first child */
        in_tree[node].child = i_i + 1;
        
        /* creation of the subtree descending from node */
        for (i = 0; i < unit->head->n_umod; i++)
        {
                i_i++;
                /* scan the param table and create nodes */
		unit->par_table[i].i_node = i_i;
                in_tree[i_i].in_name = unit->par_table[i].in_name;
                in_tree[i_i].def_name = unit->par_table[i].def_name;
                in_tree[i_i].st_addr = 0;
                in_tree[i_i].end_addr = 0;
                in_tree[i_i].intf_dim = 0;
                in_tree[i_i].intf_table = NULL;
                in_tree[i_i].father = node;
                in_tree[i_i].child = MAX_UNSIGNED;
                in_tree[i_i].brother = MAX_UNSIGNED;
                in_tree[i_i].un_addr = unit->par_table[i].un_addr;
                
                enqueue_n(in_tree[i_i].un_addr, i_i);

                if (brother != MAX_UNSIGNED) in_tree[brother].brother = i_i;
                brother = i_i;
                
                /* enqueue the node to expand it later */
                if (unit->par_table[i].un_addr->head->n_umod > 0)
                {
                        enqueue_in(i_i, 0, unit->par_table[i].un_addr);
                }
                
        }
}


/*************************************************************************

   ROUTINE:     make_param

   FUNCTION:    Create the units calls table for a given unit.

   AUTHOR(s):   Daniela Magnani

   DATE:        21/08/1986

   NOTES: 

   METHOD: 

**********************************************************************/

make_param()
{

/* external functions */

        char            *alloca();
	unsigned long	cnt_con_lst();

/* local variables */

        PARTAB_PTR      pp;
        CONN_PTR        pi;
        CONN_PTR        pl;
        unsigned long   i;
        unsigned long   d;              /* unit definition index */
        unsigned long   in;

/* code */

        /* units calls table creation */
        pp = u->par_table = (PARTAB_PTR) alloca(U_H->n_umod * sizeof(*pp));

        /* scanning unit definition list */
        for (i = 0; i < U_H->n_mod; i++)
        {
		/* d = unit definition index */
                d = U_H->list_def[i];
                enqueue_u(U_S[d]->s_tab->el_name, u->name);
                ins_fa_son(&u->son_def_list, U_S[d]->s_tab->el_name);
                /* scan the unit instantiations list */
                for (pi = U_S[d]->D.l_ist; pi != NULL; pi = pi->c_next)
                {
			(u->son_def_list->inst)++;
                        in = pi->signal;
                        /* in unit instantiation index */
                        pp->def_name = U_S[d]->s_tab->el_name;
                        pp->in_name = U_S[in]->s_tab->el_name;

                        /* set input output & bidir parameters */
                        pp->in_param = U_S[in]->U.l_fanin;
			U_S[in]->U.l_fanin = NULL;
                        pp->out_param = U_S[in]->U.l_fanout;
			U_S[in]->U.l_fanout = NULL;
                        pp->bid_param = U_S[in]->U.l_fanbin;
			U_S[in]->U.l_fanbin = NULL;

                        if (pp->in_param != NULL) 
                                elim_unit(pp->in_param, FANOUT);
                        if (pp->out_param != NULL) 
                                elim_unit(pp->out_param, FANIN);
                        if (pp->bid_param != NULL) 
                                elim_unit(pp->bid_param, LCONN);

                        pp++;
                        free_static(U_S[in]);
			U_S[in] = NULL;
                }
                free_list(U_S[d]->D.l_ist);
		free_static(U_S[d]);
		U_S[d] = NULL;
        }
	release(u->head->list_def, U_H->n_mod*sizeof(long));
	u->head->list_def = NULL;
	release(u->head->symb_def, 0);
	u->head->symb_def = NULL;
        u->head->n_top -= (u->head->n_umod + u->head->n_mod);
}


/*************************************************************************

   ROUTINE:     elim_unit

   FUNCTION:    Elimina le connessioni a units nelle liste di FANIN, FANOUT
                e CONN

   AUTHOR(s):   Daniela Magnani

   DATE:        21/08/1986

   NOTES: 	Una costante puo' avere connessione a unit solo da fanout o 
		connectivity list e puo' solo essere di tipo wire in questo
		caso.

   METHOD: 

**********************************************************************/

elim_unit(list, l_type)
CONN_PTR list;
long l_type;

{
/* external functions */

        CONN_PTR        search_ty();
        CONN_PTR        cancel();

/* local variables */

        STAT_PTR        p_el;
	CONN_PTR	aux_conn;

/* code */

        while (list != NULL)
        {
           if (list->signal != MAX_UNSIGNED)
           {
	     p_el = *(U_S + (list->signal));
             switch(p_el->code)
             {
                case NOD :
                case WIR :
                case REG :
                        if (l_type == FANIN)
                        {
                                p_el->C.l_fanin = cancel((aux_conn = 
                                              search_ty(USE, p_el->C.l_fanin)),
                                                p_el->C.l_fanin);
				free_conn(aux_conn);
                        }
                        if (l_type == FANOUT)
                        {
                                p_el->C.l_fanout = cancel((aux_conn = 
                                              search_ty(USE, p_el->C.l_fanout)),
                                                p_el->C.l_fanout);
				free_conn(aux_conn);
                        }
                        if (l_type == LCONN)
                        {
                                p_el->C.l_conn = cancel((aux_conn = 
                                               search_ty(USE, p_el->C.l_conn)),
                                                p_el->C.l_conn);
				free_conn(aux_conn);
                        }
                        break;
                case GAT :
                        if (l_type == FANIN)
                        {
                                p_el->G.l_fanin = cancel((aux_conn = 
                                               search_ty(USE, p_el->G.l_fanin)),
                                                p_el->G.l_fanin);
				free_conn(aux_conn);
                        }
                        else
                        {
                                p_el->G.l_fanout = cancel((aux_conn = 
                                              search_ty(USE, p_el->G.l_fanout)),
                                                p_el->G.l_fanout);
				free_conn(aux_conn);
                        }
                        break;
                case CONST :
			if (p_el->I.type != C_WIRE)
			     bug("Illegal constant type used in mapping");
                        if (l_type == FANOUT)
                        {
                                p_el->IW.l_fanout = cancel((aux_conn = 
                                        search_ty(USE, p_el->IW.l_fanout)),
                                                p_el->IW.l_fanout);
				free_conn(aux_conn);
                        }
                        if (l_type == LCONN)
                        {
                                p_el->IW.l_conn = cancel((aux_conn = 
                                               search_ty(USE, p_el->IW.l_conn)),
                                                p_el->IW.l_conn);
				free_conn(aux_conn);
                        }
			if (l_type == FANIN)
			  fatal("Invalid constant use in mapping");
                        break;
                default :
                        fatal("Illegal element connected to unit");
             }
           }
        list = list->c_next;
        }
}


/*************************************************************************

   ROUTINE:     ins_fa_son

   FUNCTION:    Inserisce un elemento in una lista di tipo

   AUTHOR(s):   Daniela Magnani

   DATE:        21/08/1986

   NOTES: 

   METHOD: 

**********************************************************************/

ins_fa_son(ptr, s)
UNITL_PTR *ptr;
char *s;

{
/* external functions */

        char    *alloca();

/* local variables */

        UNITL_PTR       p_queue;

/* code */

        p_queue = (UNITL_PTR) alloca(sizeof(*p_queue));

        p_queue->name = s;

	p_queue->inst = 0;

        /* LIFO insertion */
        p_queue->next = *ptr;
        *ptr = p_queue;
}


/*************************************************************************

   ROUTINE:     levelizing

   FUNCTION:    Attribuisce un livello alle unit per eseguire correttamente
                l'integrazione bottom-up.

   AUTHOR(s):   Daniela Magnani

   DATE:        21/08/1986

   NOTES: 

   METHOD:      Le unit che non ne richiamano altre hanno livello 0
                Alle unit con livello UNDEFINED viene assegnato un livello
                secondo la formula: max(livello (unit richiamate)) + 1


**********************************************************************/

levelizing()
{

/* external functions */

        UNIT_PTR        search_u();
        FIFOL_PTR       dequeue_l();
        int             strcmp();

/* local variables */

        FIFOL_PTR       p_l;
        UNITL_PTR       pf;
        UNITL_PTR       ps;
        long            newlev;
        long            lev;

/* code */

        while ((p_l = dequeue_l()) != NULL)
        {
           /* scanning father list */
           for (pf = p_l->unit_index->father_list; pf != NULL; pf = pf->next)
           {
             if (strcmp(pf->name, NULL_NAME) != 0)
             {
                /* father hash search */
                if ((u = search_u(pf->name))->level == UNDEFINED)
                {
                        newlev = 0;
                        /* scanning u son_def list */
                        ps = u->son_def_list;
                        while ((ps != NULL) && (newlev != UNDEFINED))
                        {
                           /* lev = son_unit  level */
                           lev = search_u(ps->name)->level;
                           newlev = (lev == UNDEFINED) ? lev : MAX(newlev, lev);
                           ps = ps->next;
                        }
                        /* assign level to father */
                        if (newlev != UNDEFINED)
                        {
                           if (newlev >= DIM_LEVEL - 1)
                                        fatal("units nesting overflow");
                           u->level = ++newlev;
                           enqueue_l(u->name, u);
                           insert_lev(u->level);
                        }
                }
             }
           }
	   release(p_l, sizeof(*p_l));
        }
}


/*************************************************************************

   ROUTINE:     merge_step

   FUNCTION:    Merge the topological structure of a main unit with called
                units

   AUTHOR(s):   Daniela Magnani

   DATE:        21/08/1986

   NOTES: 	Viene creato un blocco statico atto a contenere la unit main 
		e tutte le istanziazioni di unit richiamate.
		Tale blocco statico e' costituito da una array di puntatori 
		di tipo STAT_PTR. Per la main unit non istanzio nuovi 
		descrittori statici ma copio i puntatori.
		Per le unit istanziate creo nuovi descrittori statici tramite 
		la funzione new_top_el a meno che si tratti dell'ultima
		istanziazione della unit. In questo caso copio i puntatori e
		quindi elimino la necessita' di rilasciare il blocco statico
		e le liste di connectivity.
		Per le unit istanziate e' possibile che integrazioni 
		precedenti abbiano portato alla creazione di elementi
		topologici (CONST) nella lista di espansione. Tali elementi
		vengono copiati dopo gli elementi topologici della unit 
		istanziata. Gli elementi costanti creati dal linker per
		integrare ritardi hanno tipo = D_CONST e formato analogo alle
		costanti di tipo INT
	
		Gestione tabella ritardi costanti: creo una tabella di 
		puntatori a ritardi che integra tutte le tabelle contenute 
		nelle unit istanziate (posso avere liste di espansione per
		i ritardi costanti creati in fase di integrazione).
		Per le unit istanziate (a meno che non si tratti dell'ultima 
		istanziazione) devo anche allocare nuovi descrittori di ritardo
		Negli elementi topologici bisogna rinumerare gli offset alle
		tabelle di ritardi costanti e in tali tabelle bisogna 
		rinumerare gli indici dei topologici costanti in funzione
		dello start address dell'istanziazione.

   METHOD: 

**********************************************************************/

merge_step()

{
/* external functions */

        char            *alloca();
        STAT_PTR        *new_top_el();
	UNIT_PTR	search_u();
	STAT_PTR	new_top_des();

/* external variables */

	extern EHEADER	h_exe;

/* local variables */

        STAT_PTR        *p_s;
        UNIT_PTR        aux_u;
        unsigned long   n_top;
        unsigned long   loc_top;
        unsigned long   act_ind;
        unsigned long   n_del;
	ODELAY_PTR	*d_tb;
        unsigned long   act_del;
        unsigned long   loc_del;
        unsigned long   i;
        unsigned long   end_ind;
        unsigned long   aux_i;
        unsigned long   f_n;
        ODELAY_PTR      p_d;
        IN_N_PTR        p_n;
	unsigned long	j;
	unsigned long	dim;
	INTF_PTR	p_intf;
	UNITL_PTR	pf, pf_old, pson, pson_old;
	char		flag_copy;
	INTF_I_PTR	p_sn;
	INTF_PTR	p_so;
	AUX_ST_PTR	aux_old;
	ODELAY_EXP_PTR	aux_d_old;
        CONN_PTR	p_list;

/* code */
        
        new_vdd = FALSE;
        new_gnd = FALSE;
        
        n_top = U_H->n_top;
	n_del = u->n_const_del;

        /* calcolo del numero di elementi topologici e di ritardi costanti 
	   risultanti dall'integrazione */
        top_val(&n_top, &n_del);

	free_el = n_top;

        /* scan the param table in order to determine the amount of
	   interfaces of the called unit not connected.
	   For these elements we reserve room at the end of the topological
	   structure */
        for (i = 0; i < U_H->n_umod; i++)
        {
                /* scan the output list of the param table */
                for (j = 0, p_list = U_P[i].out_param; p_list != NULL;
		     j++, p_list = p_list->c_next)
                {
                        if (p_list->signal == MAX_UNSIGNED) n_top++;
                }
                /* scan the bidir list of the param table */
                for (j = 0, p_list = U_P[i].bid_param; p_list != NULL;
		     j++, p_list = p_list->c_next)
                {
                        if (p_list->signal == MAX_UNSIGNED) n_top++;
                }
	}

        /* creazione vettore corrispondenza corr */
        corr = (long*) alloca(n_top * sizeof(long));
        for (i = 0; i < n_top; i++) corr[i] = i;

        /* creazione di struttura topologica che conterra' l'integrazione */
	/* viene solo creata l'array di puntatori agli elementi statici */
        p_s = new_top_el(n_top, n_top);
	
        /* copio struttura topologica della main unit nella nuova struttura
           topologica */
        for (i = 0; i < U_H->n_top; i++) p_s[i] = U_S[i];
        /* rilascio spazio occupato da vecchia struttura array di puntatori */
	free(u->head->stat_unit);
        u->head->stat_unit = p_s;

        /* act_ind indice primo elemento disponibile */
        act_ind = U_H->n_top;

	U_H->n_top = n_top;

        /* creo elemento dummy per vdd in coda a tutti gli elementi */
        if (new_vdd)
        {
                U_H->vdd = act_ind;
                p_s[act_ind] = new_top_des();
                p_s[act_ind]->attr = PI;
                p_s[act_ind]->code = NOD;
                p_s[act_ind]->C.dim = 1;
                p_s[act_ind]->C.size = 0;
                p_s[act_ind]->C.l_fanout = NULL;
                p_s[act_ind]->C.l_fanin = NULL;
                p_s[act_ind]->C.l_conn = NULL;
                p_s[act_ind]->C.init_el = NULL;
                p_s[act_ind]->C.delay.del_ptr = p_d = 
			(ODELAY_PTR) alloca(sizeof(*p_d));
		p_s[act_ind]->C.del_type = DEL_IMM;
                p_d->rise = p_d->fall = DEF_DEL;
		p_d->rise_type = p_d->fall_type = DEL_IMM;
		p_d->time_unit = h_exe.time_unit;
                act_ind++;
        }
        if (new_gnd)
        {
                U_H->gnd = act_ind;
                p_s[act_ind] = new_top_des();
                p_s[act_ind]->attr = PI;
                p_s[act_ind]->code = NOD;
                p_s[act_ind]->C.dim = 1;
                p_s[act_ind]->C.size = 0;
                p_s[act_ind]->C.l_fanout = NULL;
                p_s[act_ind]->C.l_fanin = NULL;
                p_s[act_ind]->C.l_conn = NULL;
                p_s[act_ind]->C.init_el = NULL;
                p_s[act_ind]->C.delay.del_ptr = p_d =
			(ODELAY_PTR) alloca(sizeof(*p_d));
		p_s[act_ind]->C.del_type = DEL_IMM;
                p_d->rise = p_d->fall = DEF_DEL;
		p_d->rise_type = p_d->fall_type = DEL_IMM;
		p_d->time_unit = h_exe.time_unit;
                act_ind++;
        }

	/* creazione di struttura delay che conterra' l'integrazione */
	/* viene solo creata l'array di puntatori ai delay (se esistono
	   ritardi costanti */
	if (n_del > 0)
	{
		d_tb = (ODELAY_PTR*) alloca(n_del * sizeof(ODELAY_PTR));
        	/* copio delay table della main unit nella nuova delay
		   table */
	        for (i = 0; i < u->n_const_del;i++) d_tb[i] = u->del_con_tab[i];
        	/* rilascio spazio occupato da vecchia struttura array di 
		   puntatori a ritardo nella main unit */
		if (u->del_con_tab != NULL) free(u->del_con_tab);
        	u->del_con_tab = d_tb;
	}
        /* act_del indice primo elemento disponibile nella delay table */
        act_del = u->n_const_del;

	u->n_const_del = n_del;

        /* caricamento della struttura topologica delle unit
           richiamate - scansione param_table per determinare
           quali sono le unit istanziate dalla main unit
	   la son_def_list e' LIFO */
	aux_u = NULL;
        for (i = 0; i < U_H->n_umod; i++)
        {
		if (aux_u != U_P[i].un_addr)
		{
			aux_u = U_P[i].un_addr;
	                loc_top = aux_u->head->n_top + aux_u->exp_el;
			loc_del = aux_u->n_const_del + aux_u->n_const_del_exp;
			for (pson = u->son_def_list;
			     strcmp(pson->name, aux_u->name) != 0;
			     pson = pson->next);
			/* scan the father list of the unit aux_u in order to
			   eliminate the connection to the unit u */
			for (pf_old = NULL, pf = aux_u->father_list;
			     strcmp(pf->name, u->name) != 0;
			     pf_old = pf, pf = pf->next);
			if (pf_old == NULL)
				aux_u->father_list = pf->next;
			else
				pf_old->next = pf->next;
			free(pf);

			dim = aux_u->n_intf;
			p_intf = aux_u->intf_table;
		}

		(pson->inst)--;

                /* setto posizione iniziale in struttura integrata */
                U_P[i].start_index = act_ind;
                end_ind = act_ind + loc_top - 1;
                
                for (p_n = u->in_lst; p_n != NULL; p_n = p_n->pun)
                {
                        aux_i = i;
                        f_n = in_tree[p_n->node].child;
                        while (aux_i-- > 0) f_n = in_tree[f_n].brother;
                        in_tree[f_n].st_addr = act_ind;
                        in_tree[f_n].end_addr = end_ind;

                        in_tree[f_n].intf_dim = dim;

			p_so = p_intf;
                        p_sn = in_tree[f_n].intf_table =
                                (INTF_I_PTR) alloca(dim * sizeof(*p_sn));

                        for (j = 0; j < dim; j++)
			{
				p_sn->addr = p_so->addr;
				p_sn->f_conn = FALSE;
				p_sn++;
				p_so++;
			}
                }

                U_H->warn_cnt += aux_u->head->warn_cnt;
                /* copio struttura topologica della unit chiamata */
		flag_copy = (pson->inst == 0 && aux_u->father_list == NULL)
			? FALSE : TRUE;
                copy_un(p_s + act_ind, aux_u->head->stat_unit, act_ind,
			aux_u->head->n_top, flag_copy, act_del);
		if (aux_u->exp_list != NULL)
		   copy_exp(p_s + act_ind + aux_u->head->n_top,
			aux_u->exp_list, act_ind + aux_u->head->n_top,
			aux_u->exp_el, flag_copy);

                /* mapping vdd/gnd locale -> vdd/gnd globale */
                if (aux_u->head->vdd != MAX_UNSIGNED)
                {
                        mapping(U_H->vdd, aux_u->head->vdd + act_ind, p_s,
				U_H->vdd, NULL);
                }
                if (aux_u->head->gnd != MAX_UNSIGNED) 
                {
                        mapping(U_H->gnd, aux_u->head->gnd + act_ind, p_s,
				U_H->gnd, NULL);
                }
		/* copia della delay table (gli offset sono incrementati di 
		   act_ind) */
		if (aux_u->n_const_del > 0)
                   copy_del(d_tb + act_del, aux_u->del_con_tab, act_ind,
			aux_u->n_const_del, flag_copy);
		if (aux_u->n_const_del_exp > 0)
		   copy_exp_del(d_tb + act_del + aux_u->n_const_del,
			aux_u->del_con_exp_tab, act_ind,
			aux_u->n_const_del_exp, flag_copy);

                act_ind += loc_top;
		act_del += loc_del;
		if (!flag_copy)
		{
			/* free the static block of aux_u (array) */
			free(aux_u->head->stat_unit);
			aux_u->head->stat_unit = NULL;
			/* free the expansion list of aux_u */
			while (aux_u->exp_list != NULL)
			{
			     aux_old = aux_u->exp_list;
			     aux_u->exp_list = aux_u->exp_list->next;
			     free(aux_old);
			}
			aux_u->exp_el = 0;
			/* free the delay table of aux_u (array) */
			if (aux_u->n_const_del > 0)
			{
				free(aux_u->del_con_tab);
				aux_u->del_con_tab = NULL;
				aux_u->n_const_del = 0;
			}
			/* free the delay expansion list of aux_u */
			while (aux_u->del_con_exp_tab != NULL)
			{
			     aux_d_old = aux_u->del_con_exp_tab;
			     aux_u->del_con_exp_tab = 
				aux_u->del_con_exp_tab->next;
			     free(aux_d_old);
			}
			aux_u->n_const_del_exp = 0;
			aux_u->del_con_exp_tab = NULL;
		}
        }
}


/*************************************************************************

   ROUTINE:     top_val

   FUNCTION:    conteggia il numero complessivo di elementi topologici
                contenuti nelle unit richiamate dalla unit main u 
                (si considerano le istanziazioni delle unit).
		Vengono conteggiati anche eventuali elementi delle liste di
		espansione.

                setta a TRUE il flag new_vdd se vdd non e' definito 
                nella unit main ma e' definito in almeno una delle 
                unit richiamate
                
                setta a TRUE il flag new_gnd se gnd non e' definito 
                nella unit main ma e' definito in almeno una delle 
                unit richiamate

		Conteggia il numero di ritardi costanti contenuti nelle unit
		istanziate. Sono conteggiati anche ritardi contenuti nelle
		liste di espansione.

   AUTHOR(s):   Daniela Magnani

   DATE:        21/08/1986

   NOTES: 

   METHOD:      

**********************************************************************/

top_val(n_top, n_del)
unsigned long *n_top;
unsigned long *n_del;

{
/* external functions */

	unsigned long	cnt_con_lst();

/* local variables */

        long            i;
        long            vdd_flag = FALSE;
        long            gnd_flag = FALSE;
        UNIT_PTR        act_ptr;
	char		aux[100];

/* code */

        for (i = 0; i < U_H->n_umod; i++)
        {
                act_ptr = U_P[i].un_addr;
                /* setto i flag vdd e gnd se nella unit attuale 
                   sono definiti */
                if (act_ptr->head->vdd != MAX_UNSIGNED) vdd_flag = TRUE;
                if (act_ptr->head->gnd != MAX_UNSIGNED) gnd_flag = TRUE;
                if ((cnt_con_lst(U_P[i].in_param) != act_ptr->head->n_pi) ||
                    (cnt_con_lst(U_P[i].out_param) != act_ptr->head->n_po) ||
                    (cnt_con_lst(U_P[i].bid_param) != act_ptr->head->n_pb))
                {
                        sprintf(aux, "\nunits : %s %s\n", u->name,
						act_ptr->name);
                        fatal2("incorrect number of parameters", aux);
                }
		if ((*n_top) > (MAX_UNSIGNED - act_ptr->head->n_top -
		    act_ptr->exp_el)) fatal("Too many topological elements");
                (*n_top) += act_ptr->head->n_top;
                (*n_top) += act_ptr->exp_el;
		(*n_del) += act_ptr->n_const_del;
		(*n_del) += act_ptr->n_const_del_exp;
        }
        /* se vdd non e' definito nella main unit ma e' definito in almeno
           una delle unit richiamate (vdd_flag TRUE) devo prevedere la 
           creazione di elemento topologico dummy per vdd
           e settare il flag new_vdd a TRUE */
        if ((vdd_flag) && (U_H->vdd == MAX_UNSIGNED))
        {
                (*n_top)++;
                new_vdd = TRUE;
        }
        /* gestione gnd analoga a quella di vdd */
        if ((gnd_flag) && (U_H->gnd == MAX_UNSIGNED))
        {
                (*n_top)++;
                new_gnd = TRUE;
        }
}


/*************************************************************************

   ROUTINE:     copy_un

   FUNCTION:    copia n_el elementi topologici da source a dest
		dove sia source che dest sono arrays di puntatori a
		descrittori topologici.
		rinumera gli indici delle liste di fanin, fanout e connessione
                incrementandoli di st_add
		incrementa eventuali campi pt_el
		Per elementi RT_CNT bisogna incrementare offset di TIME

   AUTHOR(s):   Daniela Magnani

   DATE:        21/08/1986

   NOTES: 

   METHOD: 

**********************************************************************/

copy_un(d, s, st_add, n_el, flag_copy, n_del)
STAT_PTR *d;
STAT_PTR *s;
unsigned long st_add;
unsigned long n_el;
char flag_copy;		/* TRUE for copy, FALSE for TRANSFER */
unsigned long n_del;	/* index of the first constant delay */

{
/* external functions */

        CONN_PTR        inc_l();
	STAT_PTR	new_top_des();

/* local variables */

	CONN_PTR	l_conn;

/* code */
        
        while (n_el-- > 0)
        {
		if (flag_copy && *s != NULL)
		{
			*d = new_top_des();
			**d = **s;
		}
		else
	                *d = *s;
                if  (*d != NULL)
                {
		  if ((*d)->pt_el != MAX_UNSIGNED) (*d)->pt_el += st_add;

                  if ((*d)->attr != DUMMY) (*d)->attr = INTERN;
                  switch((*d)->code)
                  {
                   case NOD :
                   case WIR :
                   case REG :
                        if ((*d)->C.l_fanin != NULL) 
                                (*d)->C.l_fanin =inc_l((*s)->C.l_fanin, st_add,
							flag_copy);
                        if ((*d)->C.l_fanout != NULL)
                               (*d)->C.l_fanout=inc_l((*s)->C.l_fanout, st_add,
							flag_copy);
                        if ((*d)->C.l_conn != NULL)
                                (*d)->C.l_conn = inc_l((*s)->C.l_conn, st_add,
							flag_copy);
			if ((*d)->C.del_type != DEL_IMM)
				(*d)->C.delay.del_off += n_del;
                        break;
                   case GAT :
                        if ((*d)->G.l_fanin != NULL)
                                (*d)->G.l_fanin =inc_l((*s)->G.l_fanin, st_add,
							flag_copy);
                        if ((*d)->G.l_fanout != NULL)
                             (*d)->G.l_fanout = inc_l((*s)->G.l_fanout, st_add,
							flag_copy);
			if ((*d)->G.del_type != DEL_IMM)
				(*d)->G.delay.del_off += n_del;
                        break;
                   case TRAN :
                        (*d)->T.drain = inc_l((*s)->T.drain, st_add, flag_copy);
                        (*d)->T.gate = inc_l((*s)->T.gate, st_add, flag_copy); 
                        (*d)->T.source = inc_l((*s)->T.source,st_add,flag_copy);
                        break;
                   case RT_AS :
                   case RT_LD :
                        if ((*d)->A.l_fanin != NULL)
                                (*d)->A.l_fanin =inc_l((*s)->A.l_fanin, st_add,
							flag_copy);
                        if ((*d)->A.l_fanout != NULL)
                             (*d)->A.l_fanout = inc_l((*s)->A.l_fanout, st_add,
							flag_copy);
                        if ((*d)->A.l_code != NULL)
                             (*d)->A.l_code = inc_l((*s)->A.l_code,0,flag_copy);

			if ((*d)->A.del_type != DEL_IMM)
				(*d)->A.delay.del_off += n_del;
                        break;

                   case AS_TR :
                        if ((*d)->A.l_fanin != NULL)
                                (*d)->A.l_fanin =inc_l((*s)->A.l_fanin, st_add,
							flag_copy);
                        if ((*d)->A.l_fanout != NULL)
                             (*d)->A.l_fanout = inc_l((*s)->A.l_fanout, st_add,
							flag_copy);
                        if ((*d)->A.l_code != NULL)
                             (*d)->A.l_code = inc_l((*s)->A.l_code,0,flag_copy);

			/* scan polish in order to find TIME */
			for (l_conn= (*d)->A.l_code; l_conn != NULL;
				l_conn = l_conn->c_next)
			{
				if (l_conn->type == TIME && l_conn->signal ==
				    DEL_CON) l_conn->CT.del_p.del_off += n_del;
			}

                        break;

                   case PROC :
                        if ((*d)->P.l_tfanin != NULL)
                                (*d)->P.l_tfanin =inc_l((*s)->P.l_tfanin, st_add,
							flag_copy);
                        if ((*d)->P.l_dfanin != NULL)
                                (*d)->P.l_dfanin =inc_l((*s)->P.l_dfanin, st_add,
							flag_copy);
                        if ((*d)->P.l_fanout != NULL)
                             (*d)->P.l_fanout = inc_l((*s)->P.l_fanout, st_add,
							flag_copy);
                        if ((*d)->P.l_locvar != NULL)
                             (*d)->P.l_locvar = inc_l((*s)->P.l_locvar, st_add,
							flag_copy);
                        if ((*d)->P.l_code != NULL)
                             (*d)->P.l_code = inc_l((*s)->P.l_code,0,flag_copy);

			/* scan polish in order to find TIME */
			for (l_conn= (*d)->P.l_code; l_conn != NULL;
				l_conn = l_conn->c_next)
			{
				if (l_conn->type == TIME && l_conn->signal ==
				    DEL_CON) l_conn->CT.del_p.del_off += n_del;
			}

                        break;

                   case LOCV :
                        if ((*d)->C.l_fanin != NULL) 
                                (*d)->C.l_fanin =inc_l((*s)->C.l_fanin, st_add,
							flag_copy);
                        if ((*d)->C.l_fanout != NULL)
                               (*d)->C.l_fanout=inc_l((*s)->C.l_fanout, st_add,
							flag_copy);
                        break;

                   case RT_CN :
                   case RT_CNT :
                        if ((*d)->O.l_fanin != NULL)
                                (*d)->O.l_fanin =inc_l((*s)->O.l_fanin, st_add,
							flag_copy);
                        if ((*d)->O.l_fanout != NULL)
                             (*d)->O.l_fanout = inc_l((*s)->O.l_fanout, st_add,
							flag_copy);
                        if ((*d)->O.l_code != NULL)
                             (*d)->O.l_code = inc_l((*s)->O.l_code,0,flag_copy);

			if ((*d)->code == RT_CNT)
			{
			   /* scan polish in order to find TIME */
			   for (l_conn= (*d)->O.l_code; l_conn != NULL;
				l_conn = l_conn->c_next)
			   {
				if (l_conn->type == TIME && l_conn->signal ==
				    DEL_CON) l_conn->CT.del_p.del_off += n_del;
			   }
		        }			   
                        break;
                   case CONST :
			switch ((*d)->I.type)
			{
			   case C_WIRE :
	                        if ((*d)->IW.l_fanout != NULL)
                            	   (*d)->IW.l_fanout = inc_l((*s)->IW.l_fanout,
					 st_add, flag_copy);
				if ((*d)->IW.l_conn != NULL)
                                   (*d)->IW.l_conn = inc_l((*s)->IW.l_conn,
					 st_add, flag_copy);
				break;
			   case C_INT :
			   case D_CONST :
	                        if ((*d)->ID.l_fanout != NULL)
                                   (*d)->ID.l_fanout = inc_l((*s)->ID.l_fanout,
					 st_add, flag_copy);
	                        if ((*d)->ID.l_fanin != NULL)
                            	   (*d)->ID.l_fanin = inc_l((*s)->ID.l_fanin,
					 st_add, flag_copy);
				if ((*d)->ID.l_code != NULL)
                	           (*d)->ID.l_code = inc_l((*s)->ID.l_code,
					 0, flag_copy);
     		                break;
			   case C_CHAR :
       		                if ((*d)->IC.l_fanout != NULL)
                            	   (*d)->IC.l_fanout = inc_l((*s)->IC.l_fanout,
					st_add, flag_copy);
	                        break;
			}
			break;
                   case MEM :
                        (*d)->M.l_fanout = inc_l((*s)->M.l_fanout, st_add,
							flag_copy);
                        if ((*d)->M.l_fanin != NULL)
                             (*d)->M.l_fanin = inc_l((*s)->M.l_fanin, st_add,
							flag_copy);
			if ((*d)->M.del_type != DEL_IMM)
				(*d)->M.delay.del_off += n_del;
                        break;
                  }
                }
                d++;
                s++;
        }
}


/*************************************************************************

   ROUTINE:     inc_l

   FUNCTION:    #

   AUTHOR(s):   Daniela Magnani

   DATE:        21/08/1986

   NOTES: 

   METHOD: 

**********************************************************************/

CONN_PTR inc_l(p, ind, flag_copy)
CONN_PTR p;
unsigned long ind;
char flag_copy;		/* TRUE for copy, FALSE for TRANSFER */

{
/* external functions */

        CONN_PTR        new_c_el();
        CONN_PTR        first_c();

/* local variables */

	static CONN_PTR        p_conn;

/* code */

	if (! flag_copy)
	{
		for (p_conn = p; p_conn != NULL; p_conn = p_conn->c_next)
			p_conn->signal += ind;
		return(p);
	}

        new_c_list();
        while (p != NULL)
        {
                /* creo elemento conn per lista destinazione */
                p_conn = new_c_el(p->type,p->signal, p->CC.first, p->CC.second);
                p_conn->signal += ind;
                enqueue_c(p_conn);
                p = p->c_next;
        }
        return(first_c());
}


/*************************************************************************

   ROUTINE:     param_mapping

   FUNCTION:    #

   AUTHOR(s):   Daniela Magnani

   DATE:        21/08/1986

   NOTES: 

   METHOD: 

**********************************************************************/

param_mapping()

{
/* external functions */

        char            *alloca();
        CONN_PTR        search_ty();
        CONN_PTR        ins_last();
        CONN_PTR        cancel();
        IN_L_PTR        dequeue_in();
	char		d_tst();
	unsigned long	cnt_lst();

/* local variables */

        unsigned long   j;
        unsigned long   act;
        unsigned long   form;
        unsigned long   gt;
        unsigned long   wr;
        unsigned long   aux_i;
        unsigned long   f_n;
        unsigned long   dim;
	unsigned long	n_in;
	unsigned long	n_out;
        CONN_PTR	p_list;
        CONN_PTR        conn;
        GATE_PTR        p_g;
        CARR_PTR        p_c;
        IN_L_PTR        p_i;
        INTF_PTR        p_intf;
        INTF_PTR        p_sn;
        IN_N_PTR        p_n, p_n_old;
	char		aux_s[NAMELENGTH + NAMELENGTH + 2];
	INT_GT_PTR	aux_g;
	char		tris_flag;
	unsigned char	g_type;
                        
/* code */
                                
        /* scan the param table */
        for (par_ind = 0; par_ind < U_H->n_umod; par_ind++)
        {
                /* scan the input list of the param table */
                for (j = 0, p_list = U_P[par_ind].in_param; p_list != NULL;
		     j++, p_list = p_list->c_next)
                {
                        act = p_list->signal;
                        form = *(U_P[par_ind].un_addr->pi_table + j);
                        form += U_P[par_ind].start_index;
                        mapping(act, form, U_S, act, p_list);
                }
                /* scan the output list of the param table */
                for (j = 0, p_list = U_P[par_ind].out_param; p_list != NULL;
		     j++, p_list = p_list->c_next)
                {
                        act = p_list->signal;
                        form = *(U_P[par_ind].un_addr->po_table + j);
                        if (act != MAX_UNSIGNED)
                        {
                                form += U_P[par_ind].start_index;
				n_out = cnt_lst(form, U_S, FANOUT);
				n_in = cnt_lst(act, U_S, FANIN);
				if (n_out > 0 && n_in > 0)
				{
					   if (U_S[form]->s_tab != NULL) 
					     sprintf(aux_s, "%s%s%s",
					   	U_P[par_ind].in_name, SEP_STR,
					     U_S[form]->s_tab->el_name);
				           else
					     sprintf(aux_s, "%s%s%d",
					   	U_P[par_ind].in_name, SEP_STR,
						form);
					   warnf(aux_s);
					   count_wri++;
				}
                                if (U_S[form]->code == GAT)
                                        mapping(form, act, U_S, act, p_list);
                                else
                                        mapping(act, form, U_S, act, p_list);
                        }
			else
			{
				/* set flag for element not connected */
                                set_not_con(U_P[par_ind].i_node, form);
                                form += U_P[par_ind].start_index;
				if (U_S[form]->code == WIR && 
				    U_S[form]->C.dim == 1 &&
				    cnt_lst(form, U_S, FANIN) == 1 &&
				    U_S[form]->C.l_fanin->type == GAT)
				ins_gate(U_S[form]->C.l_fanin->signal, FALSE);
				if (U_S[form]->code != GAT)
					create_new_el_not_con(form);
			} 
               }
                /* scan the bidir list of the param table */
                for (j = 0, p_list = U_P[par_ind].bid_param; p_list != NULL;
		     j++, p_list = p_list->c_next)
                {
                        act = p_list->signal;
                        form = *(U_P[par_ind].un_addr->pb_table + j);
                        if (act != MAX_UNSIGNED)
                        {
                                form += U_P[par_ind].start_index;
                                mapping(act, form, U_S, act, p_list);
                        }
			else
			{
				/* set flag for element not connected */
				set_not_con(U_P[par_ind].i_node, form);
                                form += U_P[par_ind].start_index;
				if (U_S[form]->code == WIR && 
				    U_S[form]->C.dim == 1 &&
				    cnt_lst(form, U_S, FANIN) == 1 &&
				    U_S[form]->C.l_fanin->type == GAT)
				ins_gate(U_S[form]->C.l_fanin->signal, FALSE);
				create_new_el_not_con(form);
			} 
                }
	        /* free in_param, out_param, bid_param */
	        if (U_P[par_ind].in_param != NULL)
		{
			free_list(U_P[par_ind].in_param);
			U_P[par_ind].in_param = NULL;
		}
	        if (U_P[par_ind].out_param != NULL)
		{
			free_list(U_P[par_ind].out_param);
			U_P[par_ind].out_param = NULL;
		}
	        if (U_P[par_ind].bid_param != NULL)
		{
			free_list(U_P[par_ind].bid_param);
			U_P[par_ind].bid_param = NULL;
		}
        }

        /* scan the l_gate table in order to solve conflicts problems
           gate - wire */
        while (l_gate != NULL)
        {
		g_type = U_S[gt = l_gate->gt]->G.type;
		tris_flag = (g_type == TGP || g_type == TGN || g_type == BTRI ||
 			     (g_type >= AND_TRI && g_type <= INV_OE))
					 ? TRUE : FALSE;

                /* scan the gate's fanout list looking for wire */
                if ((conn = search_ty(WIR, U_S[gt]->G.l_fanout)) != NULL)
                {
		   /* we can merge together gate and wire iff:
		   - the wire is not PB				     &&
		   - the wire is not PI (resulting from the integration
                     between a PI and a PB)
		   - the wire's fanin list contains only one element 
		     (this element is surely a Gate)			     &&
                   - the wire is INTERN or DUMMY && the Gate is not a 
		     tristate one ||
                   - the wire is INTERN or DUMMY && the Gate is a tristate 
		     one && the wire has fanout towards a gate TGx, MTGx,
		     BUS 						   ||
		   - the wire is PO && the gate is not a tristate &&
                     wire's fanout is 0					  ||
		   - the wire is PO && the gate is a tristate and the wire 
		     has fanout towards a gate TGx, MTGx or BUS.

		   Integration gate - wire PO into the main unit is solved by
		   a next call to CHECK_GATE() */
                
		   wr = conn->signal;
		   if (U_S[wr]->attr != PB && U_S[wr]->attr != PI &&
		       cnt_lst(wr, U_S, FANIN) == 1 &&
		       (((U_S[wr]->attr == INTERN || U_S[wr]->attr == DUMMY) &&
			 (!tris_flag || search_mtb(U_S[wr]->C.l_fanout))) ||
			(U_S[wr]->attr == PO && 
			 (!tris_flag && U_S[wr]->C.l_fanout == NULL) ||
			 (tris_flag && search_mtb(U_S[wr]->C.l_fanout)))))
                        {
                                p_g = &(U_S[gt]->G);
                                p_c = &(U_S[wr]->C);

				/* function flag is ORed */
				U_S[gt]->function_flag |= U_S[wr]->function_flag;

                               	/* delay integration */
                                if (!d_tst(U_S[wr]))
       	                        {
              	                  if (d_tst(U_S[gt]))
			          {
				      p_g->del_type = p_c->del_type;
				      if (p_c->del_type == DEL_IMM)
				        p_g->delay.del_ptr = p_c->delay.del_ptr;
			              else
				        p_g->delay.del_off = p_c->delay.del_off;
				  }
				  else
                                    add_del(U_S[gt], U_S[wr]);
                                }
                                /* cancel connection gate to wire and
                                   the opposite one */
                                p_g->l_fanout = cancel(conn, p_g->l_fanout);
				free_conn(conn);
       	                        chng_conn(U_S, wr, gt);
       	                        p_g->l_fanout = ins_last(p_g->l_fanout,
               	                                        p_c->l_fanout);
				/* delete wire */
				if ((U_S[wr]->attr != INTERN &&
				    U_S[wr]->attr != DUMMY) ||
				    (U_S[wr]->attr != DUMMY &&
				     U_S[gt]->attr == DUMMY))
					U_S[gt]->attr = U_S[wr]->attr;

				/* se il wire e' nella unit main devo
				modificare la symbol table */
                                if (wr < U_P[0].start_index)
                                {
                                    U_S[gt]->G.init_el = U_S[wr]->C.init_el;
                                    if (U_S[wr]->s_tab->st_el != MAX_UNSIGNED)
                                               U_S[wr]->s_tab->st_el = gt;
                                    u->flag_res = TRUE;
                                }
				/* assign the name of the element in the 
				   external unit */
				if (! (l_gate->f_gate))
				{
				  U_S[gt]->s_tab = U_S[wr]->s_tab;
				  U_S[gt]->pt_el = wr;
				}
				free_conn(p_c->l_fanin);
				free_static(U_S[wr]);
				U_S[wr] = NULL;
				corr[wr] = gt;
                        }
                }
		aux_g = l_gate;
		l_gate = l_gate->next;
		free(aux_g);
        }

        /* aggiorno indirizzi nella interface table della main unit 
           corrente (se definita) */
        p_intf = u->intf_table;
        for (j = 0; j < u->n_intf; j++)
        {
                p_intf[j].addr = s_corr(p_intf[j].addr);
        }
                
        /* aggiorno indirizzi nelle interface tables delle istanziazioni
           dipendenti e creo interface tables per le istanziazioni richiamate 
           dalla main_unit */
        for (par_ind = 0; par_ind < U_H->n_umod; par_ind++)
        {
                for (p_n = u->in_lst; p_n != NULL; p_n = p_n->pun)
                {
                        aux_i = par_ind;
                        f_n = in_tree[p_n->node].child;
                        while (aux_i-- > 0) f_n = in_tree[f_n].brother;
                        enqueue_in(f_n, in_tree[f_n].st_addr, NULL);
                }

                while ((p_i = dequeue_in()) != NULL)
                {
                        mod_node(p_i->node, p_i->val);
			free(p_i);
                }
        }
        /* modifico main pi & po & pb table */
        if (u->pi_table != NULL) chng_tb(u->pi_table, U_H->n_pi);
        if (u->po_table != NULL) chng_tb(u->po_table, U_H->n_po);
        if (u->pb_table != NULL) chng_tb(u->pb_table, U_H->n_pb);
	free(corr);
	corr = NULL;
	/* free the param table */
	free(u->par_table);
	u->par_table = NULL;
}


/*************************************************************************

   ROUTINE:     set_not_con()

   FUNCTION:    Set flag for elements not connected in interface table

   AUTHOR(s):   Daniela Magnani

   DATE:        05/05/1987

   NOTES: 

   METHOD: 

**********************************************************************/

set_not_con(node, uncon)
unsigned long node;
unsigned long uncon;

{
/* local variables */

	INTF_I_PTR	p_intf;
        unsigned long   i;

/* code */

	p_intf = in_tree[node].intf_table;
	for (i = 0; i < in_tree[node].intf_dim; i++)
	{
		if (p_intf[i].addr == uncon) p_intf[i].f_conn = TRUE;
	}
}


/*************************************************************************

   ROUTINE:     mod_node()

   FUNCTION:    #

   AUTHOR(s):   Daniela Magnani

   DATE:        08/09/1986

   NOTES: 

   METHOD: 

**********************************************************************/

mod_node(node, st_ad)
unsigned long node;
unsigned long st_ad;

{
/* local variables */

        INTF_I_PTR      p_i;
        unsigned long   n_c;
        unsigned long   i;

/* code */
        
        p_i = in_tree[node].intf_table;
        for (i = 0; i < in_tree[node].intf_dim; i++)
        {
                p_i[i].addr = s_corr(st_ad + p_i[i].addr);
        }
        /* accedo ai figli di node */
        for (n_c = in_tree[node].child; n_c != MAX_UNSIGNED; 
                                                n_c = in_tree[n_c].brother)
        {
                in_tree[n_c].end_addr += st_ad;
                in_tree[n_c].st_addr += st_ad;
                enqueue_in(n_c, st_ad, NULL);
        }
}


/*************************************************************************

   ROUTINE:     chng_tb

   FUNCTION:    #

   AUTHOR(s):   Daniela Magnani

   DATE:        21/08/1986

   NOTES: 

   METHOD: 

**********************************************************************/

chng_tb(list, n_el)
long list[];
unsigned long n_el;

{

/* code */

        while (n_el-- > 0)
        {
                list[n_el] = s_corr(list[n_el]);
        }
}


/*************************************************************************

   ROUTINE:     s_corr

   FUNCTION:    ricerca nel vettore corr il corrispondente dell'elemento el

   AUTHOR(s):   Daniela Magnani

   DATE:        21/08/1986

   NOTES: 

   METHOD: 

**********************************************************************/

s_corr(el)
unsigned long el;

{
/* local variables */

        unsigned long   aux_v;

/* code */

        aux_v = el;
        while (aux_v != corr[aux_v]) aux_v = corr[aux_v];
        return(aux_v);
}


/*************************************************************************

   ROUTINE:     mapping

   FUNCTION:    #

   AUTHOR(s):   Daniela Magnani

   DATE:        21/08/1986

   NOTES: 

   METHOD: 

**********************************************************************/

mapping (parh, pard, p_s, act, conn_be)
unsigned long parh;
unsigned long pard;
STAT_PTR *p_s;
unsigned long act;
CONN_PTR conn_be;	/* NULL only for the integration between internal
			   and external VDD and GND */

{
/* external functions */

        CONN_PTR        new_c_el();
        CONN_PTR        ins_last();
        char		d_tst();
	unsigned long	cnt_lst();
        CONN_PTR        search_ty();

/* local variables */

        CONN_PTR        conn;
        CARR_PTR        p_ch;
        CARR_PTR        p_cd;
        GATE_PTR        p_g;
        long            ty;
        char            flag;
	int		parh_dim;
	char		bit_ex_flg;
	char		aux_buf[80];

/* code */
                        
	ty = p_s[pard]->code;
        switch (p_s[parh]->code)
        {
           case NOD :
		if (ty != NOD && ty != WIR) f_map (parh, pard, p_s);
  		if (p_s[pard]->C.dim != 1) f_map (parh, pard, p_s);

                p_ch = &(p_s[parh]->C);
                p_cd = &(p_s[pard]->C);

		if (parh == U_H->vdd || parh == U_H->gnd)
		{
/*
		   if ((p_s[pard]->function_flag & (~F_CONTROL))
                                                        != F_NO_FUNCTION)
			f_map (parh, pard, p_s);
*/
		    /* function flag is ORed */
		    p_s[parh]->function_flag |= p_s[pard]->function_flag;

		   if (p_s[pard]->C.l_fanin != NULL)
		   {
			/* mapping VDD/GND - PB with fanin
			   A warning is issued and the connection towards 
			   VDD/GND is cut */
			if (parh == U_H->vdd)
				sprintf(aux_buf, "VDD used as inout");
			else
				sprintf(aux_buf, "GND used as inout");
			sig_map(parh, pard, p_s, aux_buf);
			disconn(pard, p_s[pard]->C.l_fanin, p_s);
			p_s[pard]->C.l_fanin = NULL;
		   }
		}
		else
		{
		    /* function flag is ORed */
		    p_s[parh]->function_flag |= p_s[pard]->function_flag;

                    /* modifico size */
                    p_ch->size = MAX(p_ch->size, p_cd->size);

                    /* modifico delay */
                    /* caso a) delay[parh] = 0 & delay[pard] = 0 -->>
                                do nothing
                        b) delay[parh] != 0 & delay[pard] = 0 -->>
                                do nothing
                        c) delay[parh] = 0 & delay[pard] != 0 -->>
                                a parh associo puntatore al delay di pard
                        d) delay[parh] != 0 & delay[pard] != 0 -->>
                                creo nuovo delay somma dei due
                                                                */
                    if (!d_tst(p_s[pard]))
       	            {
              	    	if (d_tst(p_s[parh]))
			{
				p_ch->del_type = p_cd->del_type;
				if (p_cd->del_type == DEL_IMM)
				    p_ch->delay.del_ptr = p_cd->delay.del_ptr;
			        else
				    p_ch->delay.del_off = p_cd->delay.del_off;
			}
			else
                              add_del(p_s[parh], p_s[pard]);
                     }

                }
                chng_conn(p_s, pard, parh);
                p_ch->l_fanin = ins_last(p_ch->l_fanin, p_cd->l_fanin);
                p_ch->l_fanout = ins_last(p_ch->l_fanout, p_cd->l_fanout);
                p_ch->l_conn = ins_last(p_ch->l_conn, p_cd->l_conn);

                /* set delete flag for pard */
		free_static(p_s[pard]);
                p_s[pard] = NULL;
                corr[pard] = parh;
                break;

           case WIR :
                flag = FALSE;
		if (ty != NOD && ty != WIR && ty != REG) f_map(parh, pard, p_s);
		if (p_s[parh]->C.dim != 1 && ty == NOD) f_map(parh, pard, p_s);

		/* bit_extraction management */
		bit_ex_flg = FALSE;
		parh_dim = p_s[parh]->C.dim;
		if (parh_dim > 1)
		{
		   if ((parh_dim = conn_be->CC.second - conn_be->CC.first + 1)
		       != p_s[parh]->C.dim)
		   {
			bit_ex_flg = TRUE;
			/* Control onto multi carrier is forbidden (now) */
			if (p_s[pard]->function_flag == F_CONTROL)
					f_map(parh, pard, p_s);
		   }

		}
                if (parh_dim != p_s[pard]->C.dim) f_map(parh, pard, p_s);

                if (ty == REG)
                {
			/* scan wire's fanin in order to check that
			all the elements are RT_LOAD or RT_AS enabled
			by RT_CN because registers may only be conditionally
			assigned */ 
			conn = p_s[parh]->C.l_fanin;
			while (conn != NULL)
			{
			    if (conn->type != RT_AS ||
			      (search_ty(RT_CN,p_s[conn->signal]->A.l_fanin) == NULL))
				f_map(parh, pard, p_s);
/*			    if (conn->type != RT_LD && conn->type != RT_AS ||
				(conn->type == RT_AS &&
			     search_ty(RT_CN,p_s[conn->signal]->A.l_fanin) == NULL))
				f_map(parh, pard, p_s); */
			    conn = conn->c_next;
			}
                        p_s[parh]->code = REG;
                        flag = TRUE;
                }
		if (ty == NOD)
		{
			p_s[parh]->code = NOD;
                        flag = TRUE;
                }

                p_ch = &(p_s[parh]->C);
                p_cd = &(p_s[pard]->C);

		/* function flag is ORed */
		p_s[parh]->function_flag |= p_s[pard]->function_flag;

                /* modifico size */
                p_ch->size = MAX(p_ch->size, p_cd->size);

                /* modifico delay */
                /* caso a) delay[parh] = 0 & delay[pard] = 0 -->>
                                do nothing
                        b) delay[parh] != 0 & delay[pard] = 0 -->>
                                do nothing
                        c) delay[parh] = 0 & delay[pard] != 0 -->>
                                a parh associo puntatore al delay di pard
                        d) delay[parh] != 0 & delay[pard] != 0 -->>
                                creo nuovo delay somma dei due
                                                                */

                if (!d_tst(p_s[pard]))
       	        {
              	    	if (d_tst(p_s[parh]))
			{
				p_ch->del_type = p_cd->del_type;
				if (p_cd->del_type == DEL_IMM)
				    p_ch->delay.del_ptr = p_cd->delay.del_ptr;
			        else
				    p_ch->delay.del_off = p_cd->delay.del_off;
			}
			else
                              add_del(p_s[parh], p_s[pard]);
                }

                if (! bit_ex_flg)
			chng_conn(p_s, pard, parh);
		else
			chng_conn_bex(p_s, pard, parh, conn_be, FALSE);
                if (flag) chng_conn(p_s, parh, parh);
                p_ch->l_fanin = ins_last(p_ch->l_fanin, p_cd->l_fanin);
                p_ch->l_fanout = ins_last(p_ch->l_fanout, p_cd->l_fanout);
                p_ch->l_conn = ins_last(p_ch->l_conn, p_cd->l_conn);

		/* if the resulting wire has only a fanin gate we have
		   to insert the gate into the list of connections to
		   be resolved */
		if (p_s[parh]->code == WIR && p_ch->dim == 1 && 
		    cnt_lst(parh, p_s, FANIN)== 1 && p_ch->l_fanin->type == GAT)
		{
			flag = (p_cd->l_fanin != NULL) ? FALSE : TRUE;
			ins_gate(p_ch->l_fanin->signal, flag);
		}
                /* set delete flag for pard */
		free_static(p_s[pard]);
                p_s[pard] = NULL;
                corr[pard] = parh;
                break;

           case GAT :
                if (ty != WIR && ty != NOD) f_map(parh, pard, p_s);
                if ((parh_dim = p_s[pard]->C.dim) != 1)
		{
		    /* wire multi connected to gate is accepted only
		       if there is a bit_extraction mono */
		    if (parh_dim > 1)
		    {
		      if ((parh_dim= conn_be->CC.second - conn_be->CC.first + 1)
		          != p_s[pard]->C.dim)
		      {
			  bit_ex_flg = TRUE;
			  /* Control onto multi carrier is forbidden (now) */
			  if (p_s[parh]->function_flag == F_CONTROL)
					f_map(parh, pard, p_s);
		      }
 		    }
		    if (parh_dim != 1) f_map(parh, pard, p_s);
                }
                /* if the fanout list of the gate contains one
                   carrier we have to merge it with the carrier parh */
                flag = FALSE;
                if (p_s[parh]->G.l_fanout != NULL)
                {
                        conn = p_s[parh]->G.l_fanout;
                        while (conn != NULL && !flag)
                        {
                            ty = conn->type;
                            if (ty == NOD || ty == WIR)
                            {
				if (act == parh)
				   mapping(conn->signal, pard, p_s,
					conn->signal, NULL);
				else
				   mapping(pard, conn->signal, p_s,
					pard, conn_be);
                                flag = TRUE;
                            }
                            conn = conn->c_next;
                        }
                }
                if (! flag)
                {
                       /* carrier not found in the gate's fanout */
                        p_g = &(p_s[parh]->G);
                        p_cd = &(p_s[pard]->C);
                        /* insert the gate into carrier's fanin list */
                        conn = new_c_el(GAT, parh, 0, conn_be->CC.first);
                        p_cd->l_fanin = ins_last(p_cd->l_fanin, conn);
			/* transfer gate's fanout to the carrier */
	                if (! bit_ex_flg)
			{
			   conn = p_s[parh]->G.l_fanout;
		           while (conn != NULL)
                	   {
			     mod_conn(p_s, conn->signal, FANOUT, parh, pard);
			     conn = conn->c_next;
			   }
			}
			else
			   chng_conn_bex(p_s, parh, pard, conn_be, TRUE);

                        p_cd->l_fanout = ins_last(p_cd->l_fanout,
               	                                        p_g->l_fanout);

			/* function flag of the carrier is ORed with the
			   gate's function flag */
			p_s[pard]->function_flag |= p_s[parh]->function_flag;
			/* gate's function flag is reset */
			p_s[parh]->function_flag = F_NO_FUNCTION;

                        /* insert the carrier into gate's fanout list */
                        conn = new_c_el(p_s[pard]->code, pard, 
				conn_be->CC.first, conn_be->CC.first);
                        p_g->l_fanout = conn;
                        if (p_s[pard]->code == WIR && p_s[pard]->C.dim == 1)
                        {
                                /* insert the element into the list
                                   of connections gate-wire to be decided */
				flag = (act == parh) ? TRUE : FALSE;
                                ins_gate(parh, flag);
                        }
                }
                break;

           case REG :
                if (ty != REG && ty != WIR) f_map(parh, pard, p_s);

		/* bit_extraction management */
		bit_ex_flg = FALSE;
		parh_dim = p_s[parh]->C.dim;
		if (parh_dim > 1)
		{
		   if ((parh_dim = conn_be->CC.second - conn_be->CC.first + 1)
		       != p_s[parh]->C.dim)
		   {
			bit_ex_flg = TRUE;
			/* Control onto multi carrier is forbidden (now) */
			if (p_s[pard]->function_flag == F_CONTROL)
					f_map(parh, pard, p_s);
		   }
		}
                if (parh_dim != p_s[pard]->C.dim) f_map(parh, pard, p_s);

                if (ty == WIR)
                {
			/* scan wire's fanin in order to check that
			   all the elements are RT_LOAD because
			   registers may be assigned only by RT_LOAD */ 
			conn = p_s[pard]->C.l_fanin;
			while (conn != NULL)
			{
			    if (conn->type != RT_AS ||
			      (search_ty(RT_CN,p_s[conn->signal]->A.l_fanin) == NULL))
				f_map(parh, pard, p_s);

/* 			    if (conn->type != RT_LD) f_map(parh, pard, p_s); */
			    conn = conn->c_next;
			}
                }
                p_ch = &(p_s[parh]->C);
                p_cd = &(p_s[pard]->C);

		/* function flag is ORed */
		p_s[parh]->function_flag |= p_s[pard]->function_flag;

                /* modifico size */
                p_ch->size = MAX(p_ch->size, p_cd->size);

                /* modifico delay */
                if (!d_tst(p_s[pard]))
       	        {
              	    	if (d_tst(p_s[parh]))
			{
				p_ch->del_type = p_cd->del_type;
				if (p_cd->del_type == DEL_IMM)
				    p_ch->delay.del_ptr = p_cd->delay.del_ptr;
			        else
				    p_ch->delay.del_off = p_cd->delay.del_off;
			}
			else
                              add_del(p_s[parh], p_s[pard]);
                }

                if (! bit_ex_flg)
			chng_conn(p_s, pard, parh);
		else
			chng_conn_bex(p_s, pard, parh, conn_be, FALSE);
                p_ch->l_fanin = ins_last(p_ch->l_fanin, p_cd->l_fanin);
                p_ch->l_fanout = ins_last(p_ch->l_fanout, p_cd->l_fanout);
                /* marco cancellato l'elemento pard */
		free_static(p_s[pard]);
                p_s[pard] = NULL;
                corr[pard] = parh;
                break;          

        case CONST :
		/* mapping wire constant - PI or wire constant - PB
		   In this case the PB may have a fanin not empty.
                   A warning is issued and the connection towards
		   the constant is cut. */
                if (ty != WIR && ty != NOD) f_map(parh, pard, p_s);

		/* the constant must be of wire type */
		if (p_s[parh]->I.type != C_WIRE) f_map(parh, pard, p_s);

		/* Integration is accepted iff the carrier isn't
		   Control or Trigger_0 or Trigger_1 */
		if (p_s[pard]->function_flag != F_NO_FUNCTION)
			f_map(parh, pard, p_s);

		/* constant length must be equal to carrier length */
                if (p_s[parh]->I.leng != p_s[pard]->C.dim)
			f_map(parh, pard, p_s);

		if (p_s[pard]->C.l_fanin != NULL)
		{
		   sig_map(parh, pard, p_s, "Constant element used as inout");
		   disconn(pard, p_s[pard]->C.l_fanin, p_s);
		   p_s[pard]->C.l_fanin = NULL;
		}
                chng_conn(p_s, pard, parh);
                p_s[parh]->IW.l_fanout = ins_last(p_s[parh]->IW.l_fanout,
                                                  p_s[pard]->C.l_fanout);
                p_s[parh]->IW.l_conn = ins_last(p_s[parh]->IW.l_conn,
                                                p_s[pard]->C.l_conn);
                free_static(p_s[pard]);
                p_s[pard] = NULL;
                corr[pard] = parh;
                break;

        default :
                f_map(parh, pard, p_s);
                break;
        }
}


/*************************************************************************

   ROUTINE:     ins_gate

   FUNCTION:    #

   AUTHOR(s):   Daniela Magnani

   DATE:        06/11/1987

   NOTES: 

   METHOD: 	scan the list of gates to be resolved and set f_gate

**********************************************************************/
ins_gate(el, flag)
unsigned long el;
unsigned char flag;

{

/* external functions */

	char	*alloca();

/* local variables */

	long		j;
	unsigned char	found = FALSE;
	INT_GT_PTR	aux_g;
	INT_GT_PTR	aux_g_old;

/* code */

/* gestire con lista libera */

	for (aux_g = l_gate, aux_g_old = NULL;
	     aux_g != NULL && ! found; aux_g_old = aux_g, aux_g = aux_g->next)
	{
		if (aux_g->gt == el)
		{	found = TRUE;
			aux_g->f_gate &= flag;
		}
	}
	if (! found)
	{
                                
		aux_g = (INT_GT_PTR) alloca(sizeof(*aux_g));
		aux_g->f_gate = flag;
		aux_g->gt = el;
		aux_g->next = NULL;
		if (aux_g_old != NULL)
			aux_g_old->next = aux_g;
		else
			l_gate = aux_g;
	}
}


/*************************************************************************

   ROUTINE:     add_del

   FUNCTION:    create a new delay immediate or constant given as sum
		of the delays associated with the input topological elements.
		This new delay is associated with the first topological
		element.

   AUTHOR(s):   Daniela Magnani

   DATE:        31/01/1989

   NOTES: 	The first input topological element may only be a carrier or a
		gate, the second one may only be a carrier. 

   METHOD: 

**********************************************************************/

add_del(el_ptr, el_ptr1)
STAT_PTR el_ptr;
STAT_PTR el_ptr1;
{

/* external functions */

        char    	*alloca();
	long		uni_delay();
	ODELAY_PTR	search_del();

/* external variables */

	extern EHEADER	h_exe;

/* local variables */

        ODELAY_PTR      p_del;
	ODELAY_PTR	p_del1;
	ODELAY_PTR	p_d;
	ODELAY_EXP_PTR	buf_del;
	ODELAY_EXP_PTR	aux_buf;
	ODELAY_EXP_PTR	aux_buf_old;
	long		aux;
	long		aux1;
	unsigned long	del_ind;
	
/* code */
	
	/* resulting delay descriptor */
        p_d = (ODELAY_PTR) alloca (sizeof(*p_d));
	p_d->time_unit = h_exe.time_unit;

	/* set pointers to the two delays p_del and p_del1 */
	p_del = search_del(el_ptr);
	p_del1 = search_del(el_ptr1);

	aux = p_del->time_unit - h_exe.time_unit;
	aux1 = p_del1->time_unit - h_exe.time_unit;

	if (p_del->rise_type == DEL_IMM && p_del1->rise_type == DEL_IMM)
	{
		p_d->rise = uni_delay(p_del->rise, aux) +
			    uni_delay(p_del1->rise, aux1);
         	p_d->rise_type = DEL_IMM;
	}
	else
	{
		p_d->rise = unic_delay(p_del1->rise, p_del1->rise_type, aux1,
					p_del->rise, p_del->rise_type, aux);
		p_d->rise_type = DEL_CON;
	}
	if (p_del->fall_type == DEL_IMM && p_del1->fall_type == DEL_IMM)
	{
		p_d->fall = uni_delay(p_del->fall, aux) + 
			    uni_delay(p_del1->fall, aux1);
         	p_d->fall_type = DEL_IMM;
        } 
	else
	{
		p_d->fall = unic_delay(p_del1->fall, p_del1->fall_type, aux1,
					p_del->fall, p_del->fall_type, aux);
		p_d->fall_type = DEL_CON;
	}

	/* update delay pointers into the resulting static element */
	if (p_d->rise_type == DEL_IMM && p_d->fall_type == DEL_IMM)
	{
		if (el_ptr->code == GAT)
		{
			el_ptr->G.del_type == DEL_IMM;
			el_ptr->G.delay.del_ptr = p_d;
		}
		else
		{
			el_ptr->C.del_type == DEL_IMM;
			el_ptr->C.delay.del_ptr = p_d;
		}
	}
	else	
	{
		/* insert delay into the expansion delay list */
		buf_del = (ODELAY_EXP_PTR) alloca(sizeof(*buf_del));
		del_ind=buf_del->n_el = u->n_const_del + (u->n_const_del_exp++);
		buf_del->st = p_d;
		buf_del->next = NULL;
		/* update (FIFO) the expansion delay list */
		if (u->del_con_exp_tab == NULL) 
			u->del_con_exp_tab = buf_del;
		else
		{
			for (aux_buf = u->del_con_exp_tab; aux_buf!= NULL;
		    	     aux_buf_old = aux_buf, aux_buf = aux_buf->next);
			aux_buf_old->next = buf_del;
		}
		if (el_ptr->code == GAT)
		{
			el_ptr->G.del_type == DEL_CON;
			el_ptr->G.delay.del_off = del_ind;
		}
		else
		{
			el_ptr->C.del_type == DEL_CON;
			el_ptr->C.delay.del_off = del_ind;
		}
	}
}


/*************************************************************************

   ROUTINE:     uni_delay

   FUNCTION:    Transform a delay keeping into account the time unit 

   AUTHOR(s):   Daniela Magnani

   DATE:        19/09/1986

   NOTES: 

   METHOD: 

**********************************************************************/

long uni_delay(val, t_unit)
long val;
long t_unit;
{

/* local variables */

	int	i;

/* code */

  if (t_unit != 0)
  {
	for (i = 0; i < t_unit; i++)
	{
		val *= 10;
		if (val > DELAY_MAX)
		{
		        val = DELAY_MAX + 1;
			break;
		}
	}
   }
   return(val);
}


/*************************************************************************

   ROUTINE:     d_tst

   FUNCTION:    Return TRUE if the delay associated to the input element
		is immediate and has rise = fall = 0.
		Otherwise returns FALSE

   AUTHOR(s):   Daniela Magnani

   DATE:        31/01/1989

   NOTES: 	The input element may only be a CARRIER or a GATE

   METHOD: 

**********************************************************************/

char d_tst(el_ptr)
STAT_PTR el_ptr;
{

/* local variables */

	ODELAY_PTR	p_del;
	
/* code */

	switch (el_ptr->code)
	{
		case NOD :
		case WIR :
		case REG :
			p_del = (el_ptr->C.del_type == DEL_IMM) ?
				el_ptr->C.delay.del_ptr : NULL;
			break;
		case GAT :
			p_del = (el_ptr->G.del_type == DEL_IMM) ?
				el_ptr->G.delay.del_ptr : NULL;
			break;
	}
	if (p_del != NULL && p_del->rise == 0 && p_del->fall == 0)
		return(TRUE);
	else
		return(FALSE);
}


/*************************************************************************

   ROUTINE:     f_map

   FUNCTION:    #

   AUTHOR(s):   Daniela Magnani

   DATE:        21/08/1986

   NOTES: 

   METHOD: 

**********************************************************************/

f_map(act, form, p_s)
unsigned long act;
unsigned long form;
STAT_PTR *p_s;

{

/* code */
        
	sig_map(act, form, p_s, "Illegal mapping");
 
        STOP;
        exit(MOZ_ERR);
}


/*************************************************************************

   ROUTINE:     ttype

   FUNCTION:    #

   AUTHOR(s):   Daniela Magnani

   DATE:        21/08/1986

   NOTES: 

   METHOD: 

**********************************************************************/

char *ttype(el)
long el;

{
/* code */

        switch (el)
        {
                case NOD :
                        return("NOD");
                        break;
                case WIR :
                        return("WIR");
                        break;
                case REG :
                        return("REG");
                        break;
                case GAT :
                        return("GAT");
                        break;
                case CONST :
                        return("CONST");
                        break;
                default :
                        return("ILLEGAL");
                        break;
        }
}


/*************************************************************************

   ROUTINE:     chng_conn

   FUNCTION:    Transfer fanin, fanout, connectivity from the element eld to
		the element elh

   AUTHOR(s):   Daniela Magnani

   DATE:        21/08/1986

   NOTES: 	eld may be: NODE, WIRE, REGISTER, GATE, CONST.
		elh may be: NODE, WIRE, REGISTER, CONST, GATE

   METHOD: 

**********************************************************************/

chng_conn(p_s, eld, elh)
STAT_PTR *p_s;
unsigned long eld;
unsigned long elh;

{
/* local variables */

        CONN_PTR        conn;

/* code */

        switch(p_s[eld]->code)
        {
           case NOD :
           case WIR :
           case REG :
		conn = p_s[eld]->C.l_fanout;
                while (conn != NULL)
                {
                	mod_conn(p_s, conn->signal, FANOUT, eld, elh);
                        conn = conn->c_next;
                }
		conn = p_s[eld]->C.l_fanin;
                while (conn != NULL)
                {
                	mod_conn(p_s, conn->signal, FANIN, eld, elh);
                        conn = conn->c_next;
                }
		conn = p_s[eld]->C.l_conn;
                while (conn != NULL)
                {
                        mod_conn(p_s, conn->signal, LCONN, eld, elh);
			conn = conn->c_next;
                }
                break;
           case GAT :
		conn = p_s[eld]->G.l_fanout;
                while (conn != NULL)
                {
                	mod_conn(p_s, conn->signal, FANOUT, eld, elh);
                        conn = conn->c_next;
                }
		conn = p_s[eld]->G.l_fanin;
                while (conn != NULL)
                {
                	mod_conn(p_s, conn->signal, FANIN, eld, elh);
                        conn = conn->c_next;
		}
                break;
           case CONST :
		switch (p_s[eld]->I.type)
		{
		   case C_WIRE :
			conn = p_s[eld]->IW.l_fanout;
			while (conn != NULL)
			{
   		             	mod_conn(p_s, conn->signal, FANOUT, eld, elh);
    				conn = conn->c_next;
	                }
			conn = p_s[eld]->IW.l_conn;
	                while (conn != NULL)
 	                {
  		              	mod_conn(p_s, conn->signal, LCONN, eld, elh);
				conn = conn->c_next;
			}
			break;
		   case C_CHAR :
			/* used when we integrate constants in COMPACT */
			conn = p_s[eld]->IC.l_fanout;
			while (conn != NULL)
			{
   		             	mod_conn(p_s, conn->signal, FANOUT, eld, elh);
    				conn = conn->c_next;
	                }
			break;
                }
                break;
        }
}

/*************************************************************************

   ROUTINE:     chng_conn_const

   FUNCTION:    Transfer fanin, fanout, connectivity from the constant 
                element eld to 	the constant element elh

   AUTHOR(s):   Giulio Berardo

   DATE:        06-OCT-1989

   NOTES: 	eld must be: CONST.
		elh must be: CONST.

   METHOD: 

**********************************************************************/

chng_conn_const(p_s, eld, elh)
STAT_PTR *p_s;
unsigned long eld;
unsigned long elh;

{
/* local variables */

        CONN_PTR        conn;

/* code */

	switch (p_s[eld]->I.type)
	{
	   case C_WIRE :
		conn = p_s[eld]->IW.l_fanout;
		while (conn != NULL)
		{
			mod_conn_const(p_s, conn->signal, FANOUT, eld, elh);
			conn = conn->c_next;
		}
		conn = p_s[eld]->IW.l_conn;
	        while (conn != NULL)
 	        {
  		       	mod_conn_const(p_s, conn->signal, LCONN, eld, elh);
			conn = conn->c_next;
		}
		break;
	   case C_CHAR :
		/* used when we integrate constants in COMPACT */
		conn = p_s[eld]->IC.l_fanout;
		while (conn != NULL)
		{
	             	mod_conn_const(p_s, conn->signal, FANOUT, eld, elh);
			conn = conn->c_next;
		}
		break;
  	}
}


/*************************************************************************

   ROUTINE:     mod_conn

   FUNCTION:    #

   AUTHOR(s):   Daniela Magnani

   DATE:        21/08/1986

   NOTES: 

   METHOD: 

**********************************************************************/

mod_conn(p_s, el, l_type, eld, elh)
STAT_PTR *p_s;
unsigned long el;
long l_type;
unsigned long eld;
unsigned long elh;

{
/* external functions */

        CONN_PTR        search_el();

/* local variables */

        CONN_PTR        conn;
        CONN_PTR        p;

/* code */

        switch(p_s[el]->code)
        {
                case NOD :
                case WIR :
                case REG :
                case LOCV :
                        if (l_type == FANIN)
                                conn = p_s[el]->C.l_fanout;
                        else
                                conn = p_s[el]->C.l_fanin;
                        break;
                case GAT :
                        if (l_type == FANIN)
                                conn = p_s[el]->G.l_fanout;
                        else
                                conn = p_s[el]->G.l_fanin;
                        break;
                case RT_CN :
                case RT_CNT :
                        if (l_type == FANIN)
                                conn = p_s[el]->O.l_fanout;
                        else
                                conn = p_s[el]->O.l_fanin;
                        break;
                case RT_AS :
                case RT_LD :
                case AS_TR :
                        if (l_type == FANIN)
                                conn = p_s[el]->A.l_fanout;
                        else
                                conn = p_s[el]->A.l_fanin;
                        break;
                case PROC :
                        if (l_type == FANIN)
                        {
                           conn = p_s[el]->P.l_locvar;
                           while (conn != NULL)
                           {
                             if ((p = search_el(eld, conn)) != NULL)
                             {
                                p->signal = elh;
                                p->type = p_s[elh]->code;
                                conn = p->c_next;
                             }
                             else conn = NULL;
                           }
                           conn = p_s[el]->P.l_fanout;
                        }
                        else
                        {
                           conn = p_s[el]->P.l_tfanin;
                           while (conn != NULL)
                           {
                             if ((p = search_el(eld, conn)) != NULL)
                             {
                                p->signal = elh;
                                p->type = p_s[elh]->code;
                                conn = p->c_next;
                             }
                             else conn = NULL;
                           }
                           conn = p_s[el]->P.l_dfanin;
                        }
                        break;
                case TRAN :
                        if (eld == p_s[el]->T.drain->signal) 
                                        conn = p_s[el]->T.drain;
                        if (eld == p_s[el]->T.source->signal) 
                                        conn = p_s[el]->T.source;
                        if (eld == p_s[el]->T.gate->signal) 
                                        conn = p_s[el]->T.gate;
                        break;
                case MEM :
                        if (l_type == FANIN)
                                conn = p_s[el]->M.l_fanout;
                        else
                                conn = p_s[el]->M.l_fanin;
                        break;
        }
        while (conn != NULL)
        {
                if ((p = search_el(eld, conn)) != NULL)
                {
                        p->signal = elh;
                        p->type = p_s[elh]->code;
                        conn = p->c_next;
                }
                else conn = NULL;
        }
}

/*************************************************************************

   ROUTINE:     mod_conn_const

   FUNCTION:    #

   AUTHOR(s):   Giulio Berardo

   DATE:        06-OCT-1989

   NOTES: 

   METHOD: 

**********************************************************************/

mod_conn_const(p_s, el, l_type, eld, elh)
STAT_PTR *p_s;
unsigned long el;
long l_type;
unsigned long eld;
unsigned long elh;

{
/* external functions */

        CONN_PTR        search_el();

/* local variables */

        CONN_PTR        conn;
        CONN_PTR        p;

/* code */

        switch(p_s[el]->code)
        {
                case NOD :
                case WIR :
                case REG :
                case LOCV :
                        if (l_type == FANIN)
                                conn = p_s[el]->C.l_fanout;
                        else
                                conn = p_s[el]->C.l_fanin;
                        break;
                case GAT :
                        if (l_type == FANIN)
                                conn = p_s[el]->G.l_fanout;
                        else
                                conn = p_s[el]->G.l_fanin;
                        break;
                case RT_CN :
                case RT_CNT :
                        if (l_type == FANIN)
                                conn = p_s[el]->O.l_fanout;
                        else
                                conn = p_s[el]->O.l_fanin;
                        break;
                case RT_AS :
                case RT_LD :
                case AS_TR :
                        if (l_type == FANIN)
                                conn = p_s[el]->A.l_fanout;
                        else
                                conn = p_s[el]->A.l_fanin;
                        break;
                case PROC :
                        if (l_type == FANIN)
                        {
                           conn = p_s[el]->P.l_locvar;
                           while (conn != NULL)
                           {
                             if ((p = search_el(eld, conn)) != NULL)
                             {
                                p->signal = elh;
                                p->type = p_s[elh]->code;
                                conn = p->c_next;
                             }
                             else conn = NULL;
                           }
                           conn = p_s[el]->P.l_fanout;
                        }
                        else
                        {
                           conn = p_s[el]->P.l_tfanin;
                           while (conn != NULL)
                           {
                             if ((p = search_el(eld, conn)) != NULL)
                             {
                                p->signal = elh;
                                p->type = p_s[elh]->code;
                                conn = p->c_next;
                             }
                             else conn = NULL;
                           }
                           conn = p_s[el]->P.l_dfanin;
                        }
                        break;
                case TRAN :
                        if (eld == p_s[el]->T.drain->signal) 
                                        conn = p_s[el]->T.drain;
                        if (eld == p_s[el]->T.source->signal) 
                                        conn = p_s[el]->T.source;
                        if (eld == p_s[el]->T.gate->signal) 
                                        conn = p_s[el]->T.gate;
                        break;
                case MEM :
                        if (l_type == FANIN)
                                conn = p_s[el]->M.l_fanout;
                        else
                                conn = p_s[el]->M.l_fanin;
                        break;
        }
        while (conn != NULL)
        {
                if ((p = search_el(eld, conn)) != NULL)
                {
                        p->signal = elh;
                        conn = p->c_next;
                }
                else conn = NULL;
        }
}


/*************************************************************************

   ROUTINE:     compact

   FUNCTION:    #

   AUTHOR(s):   Daniela Magnani

   DATE:        21/08/1986

   NOTES: 	The main unit may contain elements in the expansion list

   METHOD: 

**********************************************************************/

compact()

{

/* external functions */

        char            *alloca();
        STAT_PTR        *new_top_el();
        HCONST_PTR      const_insearch();
        CONN_PTR        ins_last();
	unsigned long	scan_intf();
	STAT_PTR	new_top_des();

/* external variables */

	extern unsigned long	u_n_const;
	extern unsigned long	n_nint_con;

/* local variables */
        
        SYMT_PTR        p_s;
        STAT_PTR        *p_h;
        STAT_PTR        *p_const;
        HCONST_PTR      cp;
        INTF_I_PTR      p_i;
        unsigned long   i;
        unsigned long   j;
        unsigned long   ind;
        unsigned long   old_sadd;
        unsigned long   index = 0;
        unsigned long   created_constants = 0;
        unsigned long   const_area_index = U_H->n_top + u->exp_el;
	AUX_ST_PTR	buf_pt;
	ODELAY_PTR	p_del;
	ODELAY_EXP_PTR	p_d_buf;

/* code */
        
        aux = 
         (long*) alloca((U_H->n_top + u->exp_el + n_nint_con) * sizeof(long));
        for (i = 0; i < U_H->n_top + u->exp_el; i++) aux[i] = MAX_UNSIGNED;
        p_const = new_top_el(n_nint_con, n_nint_con);
        
        /* set pointer to instantiations tree */
        for (i = 0; i < inst_counter; i++)
	{
          for (j = in_tree[i].st_addr; j <= in_tree[i].end_addr; j++)
          {
             if (U_S[j] != NULL) U_S[j]->path_ptr = i;
          }
        }

        for (i = 0; i < U_H->n_top; i++)
        {
                if (U_S[i] != NULL)
                {
			if (U_S[i]->code != CONST || U_S[i]->I.type ==C_INT ||
			    U_S[i]->I.type == D_CONST)
                                aux[i] = index++;
                        else
                        {
			   /* constant of the wire or char type */
                           cp = const_insearch(U_S[i]->I.val, U_S[i]->I.type);
                           if (cp->ind == MAX_UNSIGNED)
                           {
                                cp->ind = created_constants;
                                p_const[created_constants++] = U_S[i];
                                chng_conn_const(U_S, i, cp->ind+const_area_index);
                           }
                           else
                           {
                                chng_conn_const(U_S, i, cp->ind+const_area_index);
				if (p_const[cp->ind]->I.type == C_WIRE)
				{
				   p_const[cp->ind]->IW.l_fanout = 
                                        ins_last(p_const[cp->ind]->IW.l_fanout,
                                                 U_S[i]->IW.l_fanout);
				   p_const[cp->ind]->IW.l_conn = 
                                        ins_last(p_const[cp->ind]->IW.l_conn,
                                                 U_S[i]->IW.l_conn);
				}
				else
				   p_const[cp->ind]->IC.l_fanout = 
                                        ins_last(p_const[cp->ind]->IC.l_fanout,
                                                 U_S[i]->IC.l_fanout);
                           }
                        }
                }
        }
        for (i = 0; i < u->exp_el; i++)
 		aux[i + U_H->n_top] = index++;

        for (i = 0; i < created_constants; i++)
 		aux[i + const_area_index] = index++;

        u_n_const = 0;       

        p_h = new_top_el(index, index);
        for (i = 0; i < U_H->n_top; i++)
        {
                if (aux[i] != MAX_UNSIGNED)
                {
                        ind = aux[i];
                        p_h[ind] = U_S[i];
                        switch(p_h[ind]->code)
                        {
                                case NOD :
                                case WIR :
                                case REG :
					modif(p_h[ind]->C.l_fanout);
                                        modif(p_h[ind]->C.l_fanin);
                                        modif(p_h[ind]->C.l_conn);
                                        break;
                                case GAT :
                                        modif(p_h[ind]->G.l_fanout);
  					modif(p_h[ind]->G.l_fanin);

					/* modify path_ptr */
					if (U_S[i]->pt_el != MAX_UNSIGNED)
					   p_h[ind]->path_ptr = 
						scan_intf(p_h[ind]->pt_el);
                                        break;
                                case TRAN :
                                        modif(p_h[ind]->T.drain);
                                        modif(p_h[ind]->T.gate);
                                        modif(p_h[ind]->T.source);
                                        break;
                                case RT_AS :
                                case RT_LD :
                                case AS_TR :
                                        modif(p_h[ind]->A.l_fanout);
                                        modif(p_h[ind]->A.l_fanin);
                                        break;
                                case RT_CN :
                                case RT_CNT :
                                        modif(p_h[ind]->O.l_fanout);
                                        modif(p_h[ind]->O.l_fanin);
                                        break;
                                case PROC :
                                        modif(p_h[ind]->P.l_fanout);
                                        modif(p_h[ind]->P.l_locvar);
                                        modif(p_h[ind]->P.l_tfanin);
                                        modif(p_h[ind]->P.l_dfanin);
                                        break;
                                case LOCV :
					modif(p_h[ind]->C.l_fanout);
                                        modif(p_h[ind]->C.l_fanin);
                                        break;
                                case CONST :
                                        u_n_const++;
					p_h[ind]->attr = PI;
					modif(p_h[ind]->ID.l_fanout);
					modif(p_h[ind]->ID.l_fanin);
                                        break;
                                case MEM :
                                        modif(p_h[ind]->M.l_fanout);
                                        modif(p_h[ind]->M.l_fanin);
                                        break;
                        }
                }
        }
        for (i = 0,buf_pt = u->exp_list; i < u->exp_el;
	     i++,buf_pt = buf_pt->next)
        {
		/* The expansion topological list contains only constants
		   of type D_CONST */
                if (aux[i + U_H->n_top] != MAX_UNSIGNED)
                {
                        ind = aux[i + U_H->n_top];
                        p_h[ind] = buf_pt->st;
			u_n_const++;
			modif(p_h[ind]->ID.l_fanout);
			modif(p_h[ind]->ID.l_fanin);
                }
        }

        for (i = 0; i < created_constants;i++)
        {
	        /* The expansion not integer constant area contains only
                   constants of type C_WIRE and C_CHAR */
		u_n_const++;
                ind = aux[const_area_index+i];
                p_h[ind] = p_const[i];
		p_h[ind]->attr = PI;
		if (p_h[ind]->I.type == C_WIRE)
                {
			modif(p_h[ind]->IW.l_fanout);
			modif(p_h[ind]->IW.l_conn);
                }
                else
   			modif(p_h[ind]->IC.l_fanout);
  	}

	/* modify offset to constant into the constant delay tables */
	if (u->n_const_del > 0)
	{
		for (i = 0; i < u->n_const_del; i++)
		{
			p_del = u->del_con_tab[i];
			if (p_del->rise_type != DEL_IMM)
			     p_del->rise = aux[p_del->rise];
			if (p_del->fall_type != DEL_IMM)
			     p_del->fall = aux[p_del->fall];
		}
	}
	if (u->n_const_del_exp > 0)
	{
		p_d_buf = u->del_con_exp_tab;
		while (p_d_buf != NULL)
		{
			p_del = p_d_buf->st;
			if (p_del->rise_type != DEL_IMM)
			     p_del->rise = aux[p_del->rise];
			if (p_del->fall_type != DEL_IMM)
			     p_del->fall = aux[p_del->fall];
			p_d_buf = p_d_buf->next;
		}
	}
        /* modify the instantiations tree */
        for (i = 0; i < inst_counter; i++)
        {
                /* modify start address */
                old_sadd = ind = in_tree[i].st_addr;
                while (aux[ind] == MAX_UNSIGNED) ind++;
                in_tree[i].st_addr = aux[ind];
                
                ind = in_tree[i].end_addr;
                while (aux[ind] == MAX_UNSIGNED) ind--;
                in_tree[i].end_addr = aux[ind];
                ind = in_tree[i].st_addr;

                /* modify symbol tables offsets */
                if (in_tree[i].un_addr->flag_res)
                {
                        /* scan symbol table and control offsets */
                        p_s = in_tree[i].un_addr->head->symb_unit;
                        for (j = 0; j < in_tree[i].un_addr->head->n_sym; j++)
                        {
                                if (p_s[j].st_el != MAX_UNSIGNED)
                                {
                                        p_s[j].st_el =
                                        aux[old_sadd + p_s[j].st_el] - ind;
                                }
                        }
                        in_tree[i].un_addr->flag_res = FALSE;
                }
                /* modify addresses in the interface table */
                p_i = in_tree[i].intf_table;
                for (j = 0; j < in_tree[i].intf_dim; j++)
                {
                        p_i[j].addr = aux[p_i[j].addr];
                }
        }
        
	free(u->head->stat_unit);
        u->head->stat_unit = p_h;
        U_H->n_top = index;
        if (U_H->vdd != MAX_UNSIGNED) U_H->vdd = aux[U_H->vdd];
        if (U_H->gnd != MAX_UNSIGNED) U_H->gnd = aux[U_H->gnd];
	/* update PI/PO/PB tables for the main unit */
	if (u->pi_table != NULL) mod_tb(u->pi_table, U_H->n_pi);
	if (u->po_table != NULL) mod_tb(u->po_table, U_H->n_po);
	if (u->pb_table != NULL) mod_tb(u->pb_table, U_H->n_pb);

	/* check PI in order to verify that thei fanin is NULL
	   otherwise fanin is forced to NULL
	   PI is always of carrier type */
	for (i = 0; i < U_H->n_pi; i++)
	{
	    if (U_S[j = u->pi_table[i]]->C.l_fanin != NULL)
	    {
		warn2("Input element used as inout", U_S[j]->s_tab->el_name);
		disconn(j, U_S[j]->C.l_fanin, U_S);
		U_S[j]->C.l_fanin = NULL;
	    }
	}
	/* release the space occupied */
	free(aux);
	aux = NULL;
}


/*************************************************************************

   ROUTINE:     mod_tb

   FUNCTION:    #

   AUTHOR(s):   Daniela Magnani

   DATE:        04/05/1987

   NOTES: 

   METHOD: 

**********************************************************************/

mod_tb(list, n_el)
long list[];
unsigned long n_el;

{

/* code */

        while (n_el-- > 0)
        {
                list[n_el] = aux[list[n_el]];
        }
}


/*************************************************************************

   ROUTINE:     const_insearch

   FUNCTION:    #

   AUTHOR(s):   Daniela Magnani

   DATE:        21/08/1986

   NOTES: 

   METHOD: 

**********************************************************************/

HCONST_PTR const_insearch(s, type)
char *s;
char type;

{
/* external functions */

        char    *alloca();
        int     strcmp();
	long	hash();

/* local variables */

        HCONST_PTR      p;
        long            ind;

/* code */
        
        for (p = const_headhash[ind = hash(s) % DIM_CONSTHASH]; 
                                                p != NULL; p = p->next)
        {
                if (strcmp(s, p->val) == 0 && p->type == type) return(p);
        }
        /* s not found */
        p = (HCONST_PTR) alloca(sizeof(*p));
        p->val = s;
        p->ind = MAX_UNSIGNED;
	p->type = type;
        p->next = const_headhash[ind];
        const_headhash[ind] = p;
        return(p);
}


/*************************************************************************

   ROUTINE:     modif

   FUNCTION:    #

   AUTHOR(s):   Daniela Magnani

   DATE:        21/08/1986

   NOTES: 

   METHOD: 

**********************************************************************/

modif(list)
CONN_PTR list;

{
/* code */

        while (list != NULL)
        {
                list->signal = aux[list->signal];
                list = list->c_next;
        }
}


/*************************************************************************

   ROUTINE:     check_gate

   FUNCTION:    Merge gate and wire PO if possible onto a unit

   AUTHOR(s):   Daniela Magnani

   DATE:        27/07/1987

   NOTES: 	This function is called to integrate Po wire of a main unit.
		A wire (with fanout != 0) output of a gate tristate (Gate types 
		TGP or TGN or BTRI or AND_TRI::INV_OE) is maintained but when it
		is input of a gate TGx or MTGx or BUS (Gate types in the 
		range 35::39).
		A wire with fanout = 0 is always integrated.
		A wire output of a gate not tristate is always integrated.
		
		Integration requisites are:
		wire PO with dimension equal to 1	&&
		only a GATE as fanin			&&
	      (	wire's fanout = 0			||
	        gate type not tristate 			||
		gate type tristate and wire's fanout 
		equal to TGx ot MTGx or BUS.)

   METHOD: 

**********************************************************************/

unsigned long check_gate()
{

/* external functions */

        CONN_PTR        search_ty();
        CONN_PTR        ins_last();
        CONN_PTR        cancel();
        CONN_PTR        search_el();
        char		d_tst();
	unsigned long	cnt_lst();

/* local variables */

        unsigned long   j;
        unsigned long   i;
        unsigned long   k;
        unsigned long   gt;
        unsigned long   wr;
        long            *p_list;
        CONN_PTR        conn;
        GATE_PTR        p_g;
        CARR_PTR        p_c;
	unsigned long	n_mer = 0;
	char		type;
	INTF_I_PTR	p_i;
                        
/* code */

	p_list = u->po_table;
	for (j = 0; j < U_H->n_po; j++)
	{
	   wr = *p_list;

	   if (U_S[wr]->code == WIR && 
	       U_S[wr]->C.dim == 1 &&
	       cnt_lst(wr, U_S, FANIN) == 1 &&
	      (conn = U_S[wr]->C.l_fanin)->type == GAT &&
	      (U_S[wr]->C.l_fanout == NULL ||
	      (((type = U_S[conn->signal]->G.type) < AND_TRI ||
	       (type > INV_OE && type != TGP && type != TGN &&
		type != BTRI)) || search_mtb(U_S[wr]->C.l_fanout))))

                {
			gt = conn->signal;

			/* function flag is ORed */
			U_S[gt]->function_flag |= U_S[wr]->function_flag;

                	p_g = &(U_S[gt]->G);
                        p_c = &(U_S[wr]->C);
                        /* delay integration */
                        if (!d_tst(U_S[wr]))
       	                {
              	    	   if (d_tst(U_S[gt]))
			   {
				p_g->del_type = p_c->del_type;
				if (p_c->del_type == DEL_IMM)
				    p_g->delay.del_ptr = p_c->delay.del_ptr;
			        else
				    p_g->delay.del_off = p_c->delay.del_off;
			   }
			   else
                              add_del(U_S[gt], U_S[wr]);
                        }

                        /* cancel connection gate to wire and
                           the opposite one */
                        p_g->l_fanout = cancel(search_el(wr, p_g->l_fanout),
						p_g->l_fanout);
       	                chng_conn(U_S, wr, gt);
       	                p_g->l_fanout = ins_last(p_g->l_fanout,
               	                                 p_c->l_fanout);
			/* delete wire */
			U_S[gt]->attr = U_S[wr]->attr;
			U_S[gt]->G.init_el = U_S[wr]->C.init_el;
			if (U_S[wr]->s_tab->st_el != MAX_UNSIGNED)
                        	U_S[wr]->s_tab->st_el = gt;
			u->flag_res = TRUE;

			U_S[gt]->s_tab = U_S[wr]->s_tab;

			U_S[gt]->pt_el = wr;

			free_static(U_S[wr]);
			U_S[wr] = NULL;

			/* update po table */
			*p_list = gt;

		        /* scan the interface tables in order to find 
			   references to the element wr */
		        for (i = 0; i < inst_counter; i++)
			{
			        p_i = in_tree[i].intf_table;
			        for (k = 0; k < in_tree[i].intf_dim; k++)
			        {
		                   if (p_i[k].addr == wr) p_i[k].addr = gt;
			        }
		        }

			n_mer++;
                }
	p_list++;
	}
	return(n_mer);
}


/*************************************************************************

   ROUTINE:     elim_unit_int

   FUNCTION:    Elimina le unit completamente istanziate

   AUTHOR(s):   Daniela Magnani

   DATE:        13/07/1988

   NOTES: 

   METHOD:	visito la son_def_list della unit u appena integrata. 
		Sia aux_u il generico elemento di questa lista. 
		Elimino nella father list della unit aux_u la connessione
	   	alla unit u. Se la father list di aux_u diventa vuota
	   	posso eliminare il blocco statico della unit aux_u e tutti
	   	i suoi elementi di connectivity, le pi,po e pb tables,
		la interface table.
		Gli elementi della son_def_list della unit u sono rilasciati.

**********************************************************************/

elim_unit_int()

{
/* external functions */

	UNIT_PTR	search_u();

/* local variables */

        UNIT_PTR        aux_u;
	UNITL_PTR       pf, pf_old, pson, pson_old;
	int		j;

/* code */

	for (pson = u->son_def_list, pson_old = NULL; pson != NULL;
	     pson_old = pson, pson = pson->next)
	{
		if (pson_old != NULL) free(pson_old);
		aux_u = search_u(pson->name);

		if (aux_u->father_list == NULL)
		{
		  if (aux_u->pi_table != NULL)
		  {
			free(aux_u->pi_table);
			aux_u->pi_table = NULL;
		  }
		  if (aux_u->po_table != NULL)
		  {
			free(aux_u->po_table);
			aux_u->po_table = NULL;
		  }
		  if (aux_u->pb_table != NULL)
		  {
			free(aux_u->pb_table);
			aux_u->pb_table = NULL;
		  }
		}
	}
	if (pson_old != NULL) free(pson_old);
}


/*************************************************************************

   ROUTINE:     scan_intf

   FUNCTION:    return the path of an element

   AUTHOR(s):   Daniela Magnani

   DATE:        13/07/1988

   NOTES: 

   METHOD:	

**********************************************************************/

unsigned long scan_intf(n_el)
unsigned long n_el;

{

/* local variables */

	int	i;

/* code */

        for (i = 0; i < inst_counter; i++)
	{
           if (in_tree[i].child == MAX_UNSIGNED)
	   {
		if (n_el >= in_tree[i].st_addr && n_el <= in_tree[i].end_addr)
			return(i);
	   }
	   else
	   {
		if (n_el >= in_tree[i].st_addr &&
		    n_el < in_tree[in_tree[i].child].st_addr)
			return(i);
	   }
        }
}


/*************************************************************************

   ROUTINE:     search_mtb

   FUNCTION:    Scan a gate's fanout list and return TRUE if the gate connected
		is a TGx or MTGx or BUS one. Otherwise returns FALSE

   AUTHOR(s):   Daniela Magnani

   DATE:        27/07/1987

   NOTES: 	

   METHOD: 

**********************************************************************/

search_mtb(list)
CONN_PTR list;

{

/* code */

	while (list != NULL)
	{
		if (U_S[list->signal]->G.type >= TGP && 
		    U_S[list->signal]->G.type <= BDOWN) return(TRUE);
		list = list->c_next;
	}
	return(FALSE);
}


/*************************************************************************

   ROUTINE:     sig_map

   FUNCTION:    #

   AUTHOR(s):   Daniela Magnani

   DATE:        21/08/1986

   NOTES: 

   METHOD: 

**********************************************************************/

sig_map(act, form, p_s, s)
unsigned long act;
unsigned long form;
STAT_PTR *p_s;
char *s;

{
/* external functions */

        char    *ttype();

/* code */
        
        printf("\n%s on units : %s - %s (%s)\n",
                        s, u->name, U_P[par_ind].in_name,
                        U_P[par_ind].def_name);

        printf("on parameters : actual ");
        if (p_s[act]->s_tab != NULL) 
                printf("%s (%s)", p_s[act]->s_tab->el_name,
				  ttype(p_s[act]->code));
        else
	{
	  if (p_s[act]->code == CONST)
		printf("'%s", p_s[act]->I.val);		
	  else
	  {
		if (act == U_H->vdd)
			printf("VDD");
		else
		if (act == U_H->gnd)
			printf("GND");
		else
		printf("%d (%s)", act, ttype(p_s[act]->code));
	   }
	}

        printf(" - formal ");
        if (p_s[form]->s_tab != NULL) 
                printf("%s (%s)\n", p_s[form]->s_tab->el_name,
				  ttype(p_s[form]->code));
        else
	{
	  if (p_s[form]->code == CONST)
		printf("'%s\n", p_s[form]->I.val);		
	  else
	  {
		if (form == U_H->vdd)
			printf("VDD");
		else
		if (form == U_H->gnd)
			printf("GND");
		else
		printf("%d (%s)\n", form, ttype(p_s[form]->code));
	   }
	}
}


/*************************************************************************

   ROUTINE:     disconn

   FUNCTION:    Scan the fanin list of a carrier and disconnect this element
		from the elements writing into.

   AUTHOR(s):   Daniela Magnani

   DATE:        21/08/1986

   NOTES: 	The input element may only be a carrier.
		The element writing may be a gate or a RT block.

   METHOD: 

**********************************************************************/

disconn(el, list, p_s)
int el;
CONN_PTR list;
STAT_PTR *p_s;

{

/* external functions */

	CONN_PTR	search_el();
	CONN_PTR	cancel();

/* local variables */

	int		eld;
	CONN_PTR	flist;
	CONN_PTR	aux_conn;

/* code */

	while (list != NULL)
	{
		eld = list->signal;
		switch(p_s[eld]->code)
		{
		   case GAT :
			while ((aux_conn = search_el(el, p_s[eld]->G.l_fanout))
				!= NULL)
			{
				p_s[eld]->G.l_fanout = 
					cancel(aux_conn, p_s[eld]->G.l_fanout);
				free_conn(aux_conn);
			}
			break;
		   case RT_AS :
		   case RT_LD :
		   case AS_TR :
			while ((aux_conn = search_el(el, p_s[eld]->A.l_fanout))
				!= NULL)
			{
				p_s[eld]->A.l_fanout = 
					cancel(aux_conn, p_s[eld]->A.l_fanout);
				free_conn(aux_conn);
			}
			break;
 		   case RT_CN :
 		   case RT_CNT :
			while ((aux_conn = search_el(el, p_s[eld]->C.l_fanout))
				!= NULL)
			{
				p_s[eld]->C.l_fanout = 
					cancel(aux_conn, p_s[eld]->C.l_fanout);
				free_conn(aux_conn);
			}
			break;
                   default:
                        bug("Unexpected code found in function disconn");
		}
		list = list->c_next;
	}
}

		
/*************************************************************************

   ROUTINE:     chng_conn_bex

   FUNCTION:    Chng_conn used for bit extraction.
		move connections towards the element eld towards the
		element elh.
		Eld may be: WIRE, REGISTER, GATE.
		Elh may be: WIRE or REGISTER (Bit extraction).
		The bit extraction is accomplished always onto elh.
		The input ONLY_FANOUT is TRUE when the routine is called in
		order to transfer gate's fanout to a carrier.
		When eld is in the fanin list of an RT element we have to
		change the polish appendix also.

   AUTHOR(s):   Daniela Magnani

   DATE:        21/08/1986

   NOTES: 	

   METHOD: 

**********************************************************************/

chng_conn_bex(p_s, eld, elh, conn_be, only_fanout)
STAT_PTR *p_s;
unsigned long eld;
unsigned long elh;
CONN_PTR conn_be;
unsigned char only_fanout;

{
/* external functions */

        CONN_PTR        search_el();

/* local variables */

        CONN_PTR        conn;
	CONN_PTR	p;
	CONN_PTR	p1,p2;
	int		fanin_offset,proc_dfanin_offset;

/* code */

	if (p_s[eld]->code == GAT)
		conn = p_s[eld]->G.l_fanout;
	else
		conn = p_s[eld]->C.l_fanout;

	while (conn != NULL)
        {
		switch (p_s[conn->signal]->code)
		{
		   case GAT :
			/* The connections from the gate towards the element
			   eld are resolved all together.
			   eld[i] and eld[j] input of the same gate */
			p = p_s[conn->signal]->G.l_fanin;
			while (p != NULL)
		        {
			   if ((p = search_el(eld, p)) != NULL)
			   {
				p->signal = elh;
				p->type = p_s[elh]->code;
				p = p->c_next;
			   }
			}
			conn->CC.second += conn_be->CC.first;
			break;
		   case TRAN :
			/* The connection is towards the transistor's gate */
			p = p_s[conn->signal]->T.gate;
			p->signal = elh;
			p->type = p_s[elh]->code;
			p->CC.first += conn_be->CC.first;
			p = p->c_next;
			conn->CC.second += conn_be->CC.first;
			break;
		   case RT_AS :
		   case RT_LD :
		   case AS_TR :
                        p = p_s[conn->signal]->A.l_fanin;
			fanin_offset = 0;
			/* scan fanin list and determine offset then scan polish
			   and modify the record OPERAND - fanin offset */
			while (p != NULL)
		        {
			   if (p->signal == eld)
			   {
				p->signal = elh;
				p->type = p_s[elh]->code;
				p->CC.first += conn_be->CC.first;
				p1 = p_s[conn->signal]->A.l_code;
				while (p1 != NULL)
				{
				   if (p1->signal == fanin_offset &&
				       p1->type == OPERAND)
				   {
					p1->CC.second = p1->CC.second - 
					   p1->CC.first + conn_be->CC.first;
					p1->CC.first += conn_be->CC.first;
				   }
				   p1 = p1->c_next;
				}
			   }
			   p = p->c_next;
			   fanin_offset++;
			}
			break;
		   case PROC :
                        p = p_s[conn->signal]->P.l_dfanin;
			fanin_offset = 0;
			/* scan fanin list and determine offset then scan polish
			   and modify the record OPERAND - fanin offset */
			while (p != NULL)
		        {
			   if (p->signal == eld)
			   {
				p->signal = elh;
				p->type = p_s[elh]->code;
				p->CC.first += conn_be->CC.first;
				p1 = p_s[conn->signal]->P.l_code;
				while (p1 != NULL)
				{
                                   int dfanin_offs;
                                   if (p1->type == OP_EXEC)
                                   {
                                     proc_dfanin_offset= -1;
                                     for (p2=p1->c_next,dfanin_offs=0;
                                         dfanin_offs < p1->signal;
                                         p2=p2->c_next,dfanin_offs++)
                                       if (p2->signal == fanin_offset &&
 				           p2->type == GLOBAL_OP) 
                                         proc_dfanin_offset=dfanin_offs;
                                     for (p1=p2;
                                          p1 != NULL && p1->type != OP_EXEC;
                                          p1=p1->c_next)
                                       if (p1->signal == proc_dfanin_offset &&
                                           p1->type == OPERAND)
  				       {
					 p1->CC.second = p1->CC.second - 
					   p1->CC.first + conn_be->CC.first;
					 p1->CC.first += conn_be->CC.first;
				       }
                                   }
                                   else p1=p1->c_next;
                                }
			   }
			   p = p->c_next;
			   fanin_offset++;
			}
			break;
		   case RT_CN :
		   case RT_CNT :
                        p = p_s[conn->signal]->O.l_fanin;
			fanin_offset = 0;
			/* scan fanin list and determine offset then scan polish
			   and modify the record OPERAND - fanin offset */
			while (p != NULL)
		        {
			   if (p->signal == eld)
			   {
				p->signal = elh;
				p->type = p_s[elh]->code;
				p->CC.first += conn_be->CC.first;
				p1 = p_s[conn->signal]->O.l_code;
				while (p1 != NULL)
				{
				   if (p1->signal == fanin_offset &&
				       p1->type == OPERAND)
				   {
					p1->CC.second = p1->CC.second - 
					   p1->CC.first + conn_be->CC.first;
					p1->CC.first += conn_be->CC.first;
				   }
				   p1 = p1->c_next;
				}
			   }
			   p = p->c_next;
			   fanin_offset++;
			}
			break;
		}
        	conn = conn->c_next;
        }

	if (! only_fanout)
	{
	  if (p_s[eld]->code == GAT)
		conn = p_s[eld]->G.l_fanin;
	  else
		conn = p_s[eld]->C.l_fanin;
	  while (conn != NULL)
          {
		switch (p_s[conn->signal]->code)
		{
		   case GAT :
			p = p_s[conn->signal]->G.l_fanout;
			while (p != NULL)
		        {
			   if ((p = search_el(eld, p)) != NULL)
			   {
				p->signal = elh;
				p->type = p_s[elh]->code;
				p->CC.first += conn_be->CC.first;
				p = p->c_next;
			   }
			}
			conn->CC.first += conn_be->CC.first;
			break;
		   case RT_AS :
		   case RT_LD :
		   case AS_TR :
                        p = p_s[conn->signal]->A.l_fanout;
			while (p != NULL)
		        {
			   if ((p = search_el(eld, p)) != NULL)
			   {
				p->signal = elh;
				p->type = p_s[elh]->code;
				p->CC.first += conn_be->CC.first;
				p->CC.second += conn_be->CC.first;
				p = p->c_next;
			   }
			}
			conn->CC.first += conn_be->CC.first;
			break;
		   case RT_CN :
		   case RT_CNT :
                        p = p_s[conn->signal]->O.l_fanout;
			while (p != NULL)
		        {
			   if ((p = search_el(eld, p)) != NULL)
			   {
				p->signal = elh;
				p->type = p_s[elh]->code;
				p->CC.first += conn_be->CC.first;
				p->CC.second += conn_be->CC.first;
				p = p->c_next;
			   }
			}
			conn->CC.first += conn_be->CC.first;
			break;

		   case MEM :
                        p = p_s[conn->signal]->M.l_fanout;
			while (p != NULL)
		        {
			   if ((p = search_el(eld, p)) != NULL)
			   {
				p->signal = elh;
				p->type = p_s[elh]->code;
				p->CC.first += conn_be->CC.first;
				p = p->c_next;
			   }
			}
			conn->CC.first += conn_be->CC.first;
			break;
                       
                   default:
                        bug("Unexpected code found in function chng_conn_bex");
		}
        	conn = conn->c_next;
	  }
        }
	if (p_s[eld]->code != GAT && p_s[eld]->C.l_conn != NULL)
		bug("Connectivity in bit_ex");
}


/*************************************************************************

   ROUTINE:     copy_exp

   FUNCTION:    copia n_el elementi topologici da source a dest
		dove dest e' array di puntatori a descrittori topologici.
		Source e' invece lista (di espansione) di puntatori a 
		descrittori topologici di tipo CONST (D_CONST).
		rinumera gli indici delle liste di fanin e fanout 
		incrementandoli di st_add

   AUTHOR(s):   Daniela Magnani

   DATE:        21/08/1986

   NOTES: 	Lconn is surely NULL

   METHOD: 

**********************************************************************/

copy_exp(d, s, st_add, n_el, flag_copy)
STAT_PTR *d;
AUX_ST_PTR s;
unsigned long st_add;
unsigned long n_el;
char flag_copy;		/* TRUE for copy, FALSE for TRANSFER */

{
/* external functions */

        CONN_PTR        inc_l();
	STAT_PTR	new_top_des();

/* code */
        
        while (n_el-- > 0)
        {
		if (flag_copy)
		{
			*d = new_top_des();
			**d = *(s->st);
		}
		else
	                *d = s->st;

		if ((*d)->ID.l_fanout != NULL)
                	(*d)->ID.l_fanout = inc_l((s->st)->ID.l_fanout, st_add,
							flag_copy);
                if ((*d)->ID.l_fanin != NULL)
                	(*d)->ID.l_fanin = inc_l((s->st)->ID.l_fanin, st_add,
							flag_copy);
                if ((*d)->ID.l_code != NULL)
                        (*d)->ID.l_code = inc_l((s->st)->ID.l_code, 0,
							flag_copy);

                d++;
                s = s->next;
        }
}


/*************************************************************************

   ROUTINE:     unic_delay

   FUNCTION:    Integrate two constant delays or a constant with an
		immediate one.
		We try to not duplicate constants (of type D_CONST only)

   AUTHOR(s):   Daniela Magnani

   DATE:        19/09/1986

   NOTES: 	

   METHOD: 

**********************************************************************/

long unic_delay(val, type, t_unit, val1, type1, t_unit1)
long val;
char type;
long t_unit;
long val1;
char type1;
long t_unit1;
{

/* external functions */

	char		*alloca();
	STAT_PTR	new_top_des();
	CONN_PTR	new_c_el();
	CONN_PTR	ins_last();
	long		del_int();
	char		*strsave();
	STAT_PTR	ret_ptr_exp();
	long		uni_delay();
	long		const_int();

/* local variables */

	AUX_ST_PTR	buf_pt, aux_buf, aux_buf_old;
	STAT_PTR	pc;
	CONN_PTR	l_conn;
	CONN_PTR	l_conn1;
	long		res1;
	long		res2;
	char		as_val[255];
	long 		aux_val;
	char 		aux_type;
	long 		aux_t_unit;
	char		found = FALSE;
	long		ret_v;

/* code */

  /* The immediate delay is always given first */
  if (type == DEL_CON && type1 == DEL_IMM)
  {
	/* swap the parameters */
	aux_val = val;
	aux_type = type;
	aux_t_unit = t_unit;
	val = val1;
	type = type1;
	t_unit = t_unit1;
	val1 = aux_val;
	type1 = aux_type;
	t_unit1 = aux_t_unit;
   }

   /* if the immediate is 0 and no scaling onto val1 is required
      we return val1 */
   if (type == DEL_IMM && val == 0 && t_unit1 == 0)
   {
	ret_v = val1;
	found = TRUE;
   }
   else
   {
	/* case 1 - Immediate 0 and scaling onto val1 required
	   case 2 - Immediate not 0 + constant (scaling possible onto both
		    immediate both val1 )
	   case 3 - constant + constant (scaling onto both constants is
		    possible)
	   we look for an already created delay constant (of D_CONST type only)
	   which implements the required integration (we analyze the second
	   parameter because it is surely the constant one) */

	pc = ret_ptr_exp(val1);

	for (l_conn = pc->ID.l_fanout; l_conn != NULL && !found;
	     l_conn = l_conn->c_next)
	{
	   pc = ret_ptr_exp(l_conn->signal);
	   if (pc->I.type == D_CONST)
	   {
		/* scan the fanin of the element in the fanout of val1
		   (We suppose that the fanin length is max. 2) */
		l_conn1 = pc->ID.l_fanin;
		if (l_conn1->c_next != NULL && type == DEL_CON &&
		   (l_conn1->signal == val && l_conn1->c_next->signal==val1)||
		   (l_conn1->signal == val1 && l_conn1->c_next->signal==val)) 
		{
			found = TRUE;
			ret_v = l_conn->signal;
		}
		else
		{
		   if (l_conn1->c_next == NULL && l_conn1->signal == val1 &&
		       type == DEL_IMM && val == 0 && t_unit1 != 0)
		   {
			/* examine polish */
			l_conn1 = pc->ID.l_code;
			if (l_conn1->type == OPERAND && 
			    l_conn1->c_next->type == IMMEDIATE &&
			    l_conn1->c_next->c_next->type == OPERATOR &&
			    l_conn1->c_next->c_next->signal == M_MPY &&
			    l_conn1->c_next->signal == uni_delay(1, t_unit1))
			{
				found = TRUE;
				ret_v = l_conn->signal;
			}
		   }
		}
	   }
	}
	
	if (! found)
	{
		/* genero nuovo blocco costante che sara' agganciato alla lista
		   di espansione */
		buf_pt = (AUX_ST_PTR) alloca(sizeof(*buf_pt));
		buf_pt->n_el = U_H->n_top + (u->exp_el++);
		pc = buf_pt->st = new_top_des();
		buf_pt->st_ev = NULL;
		buf_pt->next = NULL;
	
		pc->attr = PI;
		pc->code = CONST;

		pc->I.type = D_CONST;
		pc->ID.l_fanout = NULL;
		pc->ID.l_fanin = NULL;
		pc->ID.l_code = NULL;

		/* first parameter management */
		res1 = (type == DEL_IMM && val == 0) ? 0 :
			const_int(val, type, t_unit, pc, buf_pt->n_el);
		/* second parameter management */
		res2 = const_int(val1, type1, t_unit1, pc, buf_pt->n_el);

		if (type != DEL_IMM || val != 0)
		{
			/* M_ADD operator */
			pc->ID.l_code = ins_last(pc->ID.l_code, 
				new_c_el(OPERATOR, M_ADD, 1, 0));
		}
		/* STOP CODE generation */
		pc->ID.l_code = ins_last(pc->ID.l_code, 
			new_c_el(STOP_C, STOP_AS, 1, 0));

		/* value evaluation as res1 + res2 (overflow is checked) */
		if (res1 > MAX_UNSIGNED - res2)
			pc->ID.evval = MAX_UNSIGNED;
		else
			pc->ID.evval = res1 + res2;
		sprintf(as_val, "%d", pc->ID.evval);
		pc->I.val = strsave(as_val);
		pc->I.leng = strlen(as_val);
	
		/* update (FIFO) the exp list */
		if (u->exp_list == NULL) 
			u->exp_list = buf_pt;
		else
		{
			for (aux_buf = u->exp_list; aux_buf!= NULL;
		    	     aux_buf_old = aux_buf, aux_buf = aux_buf->next);
			aux_buf_old->next = buf_pt;
		}
		ret_v = buf_pt->n_el;
	}
   }
	return(ret_v);
}


/*************************************************************************

   ROUTINE:     const_int

   FUNCTION:    

   AUTHOR(s):   Daniela Magnani

   DATE:        19/09/1986

   NOTES: 	

   METHOD: 

**********************************************************************/

long const_int(val, type, t_unit, pc, n_el)
long val;
char type;
long t_unit;
STAT_PTR pc;
long n_el;
{

/* external functions */

	CONN_PTR	inc_l();
	CONN_PTR	new_c_el();
	CONN_PTR	ins_last();
	long		uni_delay();
	STAT_PTR	ret_ptr_exp();

/* local variables */

	CONN_PTR	l_conn;
	STAT_PTR	ps;
	AUX_ST_PTR	buf;
	long		e_val;
	long		e_val1;
	long		in_off;
	
/* code */

	e_val1 = 1;

	if (type == DEL_IMM)
	{
		/* immediate value - new polish creation 
		   The immediate value is always given first */
		/* POLISH : immediate - value - type int */
		l_conn = new_c_el(IMMEDIATE, val, C_INT, 0);
		pc->ID.l_code = l_conn;
                if (val > MAX_SHORTINT)
                {
  		  l_conn = new_c_el(OPERATOR, _NOP, 0, 0);
  		  pc->ID.l_code = ins_last(pc->ID.l_code, l_conn);
                }
		e_val = val;
	}
	else
	{
		ps = ret_ptr_exp(val);
		/* value expressed as constant */
		/* POLISH : operand - offset in the fanin list
		   start bit 0 - stop bit constant length - 1 */
		/* FANIN - format of the fanin list of the RT ass */
		l_conn = new_c_el(ps->code, val, 0, C_DATA);
		
		if (pc->ID.l_fanin == NULL)
		{
			pc->ID.l_fanin = l_conn;
			in_off = 0;
		}
		else
		{
			pc->ID.l_fanin = ins_last(pc->ID.l_fanin, l_conn);
			in_off = 1;
		}
		l_conn = new_c_el(OPERAND, in_off, 0, ps->I.leng - 1);
		pc->ID.l_code = (pc->ID.l_code == NULL)
			? l_conn
			: ins_last(pc->ID.l_code, l_conn);
		e_val = ps->ID.evval;
		/* update the fanout of the element val */
		l_conn = new_c_el(CONST, n_el, 0, 0);
		ps->ID.l_fanout = (ps->ID.l_fanout == NULL)
			? l_conn
			: ins_last(ps->ID.l_fanout, l_conn);
		
	}
	/* delay scaling */
	if (t_unit != 0)
	{
		e_val1 = uni_delay(1, t_unit);
		l_conn = new_c_el(IMMEDIATE, e_val1, C_INT, 0);
		pc->ID.l_code = ins_last(pc->ID.l_code, l_conn);
                if (e_val1 > MAX_SHORTINT)
                {
  		  l_conn = new_c_el(OPERATOR, _NOP, 0, 0);
  		  pc->ID.l_code = ins_last(pc->ID.l_code, l_conn);
                }
		/* operator M_MPY */
		l_conn = new_c_el(OPERATOR, M_MPY, 1, 0);
		pc->ID.l_code = ins_last(pc->ID.l_code, l_conn);
	}
	/* value evaluation as e_val * e_val1 */
	if (e_val > (MAX_UNSIGNED / e_val1))
		e_val = MAX_UNSIGNED;
	else
		e_val *= e_val1;		
	return(e_val);	
}

/*************************************************************************

   ROUTINE:     ret_ptr_exp

   FUNCTION:    Return the pointer to the topological descriptor
		for an element which may be in the expansion list
		or into the topological standard structure

   AUTHOR(s):   Daniela Magnani

   DATE:        19/09/1986

   NOTES: 	

   METHOD: 

**********************************************************************/

STAT_PTR ret_ptr_exp(val1)
long val1;
{

/* local variables */

	AUX_ST_PTR	buf_pt;
	STAT_PTR	pc;

/* code */

	if (val1 >= U_H->n_top)
	{
		/* scan the expression list in order to find the
		   element val1 */
		for (buf_pt = u->exp_list; buf_pt->n_el != val1; 
			     		buf_pt = buf_pt->next);
		pc = buf_pt->st;
	}
	else
		pc = U_S[val1];

	return(pc);
}


/*************************************************************************

   ROUTINE:     copy_del

   FUNCTION:    copia n_el descrittori di ritardo da source a dest
		dove sia source che dest sono arrays di puntatori a
		descrittori di ritardo.
		incrementa di st_add gli indici dei ritardi costanti.
		Se il flag_copy e' TRUE alloca nuovi descrittori di ritardo
		altrimenti modifica quelli esistenti.

   AUTHOR(s):   Daniela Magnani

   DATE:        21/08/1986

   NOTES: 

   METHOD: 

**********************************************************************/

copy_del(d, s, st_add, n_el, flag_copy)
ODELAY_PTR *d;
ODELAY_PTR *s;
unsigned long st_add;
unsigned long n_el;
char flag_copy;		/* TRUE for copy, FALSE for TRANSFER */

{
/* external functions */

	char	*alloca();

/* local variables */

	ODELAY_PTR	p_d;

/* code */
        
	if (flag_copy)
	{
		p_d = (ODELAY_PTR) alloca(n_el * sizeof(*p_d));
	}
        while (n_el-- > 0)
        {
		if (flag_copy)
		{
			*d = p_d++;
			**d = **s;
		}
		else
	                *d = *s;

		if ((*d)->rise_type != DEL_IMM) (*d)->rise += st_add;
		if ((*d)->fall_type != DEL_IMM) (*d)->fall += st_add;

		s++;
		d++;
        }
}


/*************************************************************************

   ROUTINE:     copy_exp_del

   FUNCTION:    copia n_el descrittori di ritardo da source a dest
		dove dest e' array di puntatori a descrittori di ritardo
		e source e' una lista di espansione di ritardi.
		incrementa di st_add gli indici dei ritardi costanti.
		Se il flag_copy e' TRUE alloca nuovi descrittori di ritardo
		altrimenti modifica quelli esistenti.

   AUTHOR(s):   Daniela Magnani

   DATE:        21/08/1986

   NOTES: 

   METHOD: 

**********************************************************************/

copy_exp_del(d, s, st_add, n_el, flag_copy)
ODELAY_PTR *d;
ODELAY_EXP_PTR s;
unsigned long st_add;
unsigned long n_el;
char flag_copy;		/* TRUE for copy, FALSE for TRANSFER */

{
/* external functions */

	char	*alloca();

/* local variables */

	ODELAY_PTR	p_d;

/* code */
        
	if (flag_copy)
	{
		p_d = (ODELAY_PTR) alloca(n_el * sizeof(*p_d));
	}
        while (n_el-- > 0)
        {
		if (flag_copy)
		{
			*d = p_d++;
			**d = *(s->st);
		}
		else
	                *d = s->st;

		if ((*d)->rise_type != DEL_IMM) (*d)->rise += st_add;
		if ((*d)->fall_type != DEL_IMM) (*d)->fall += st_add;

		s++;
		d++;
        }
}


/*************************************************************************

   ROUTINE:     search_del

   FUNCTION:    set the delay pointer.

   AUTHOR(s):   Daniela Magnani

   DATE:        31/01/1989

   NOTES: 	The input topological element may only be a carrier or a
		gate

   METHOD: 

**********************************************************************/

ODELAY_PTR search_del(el_ptr)
STAT_PTR el_ptr;
{

/* external functions */

	ODELAY_PTR	set_off_del();

/* local variables */

	ODELAY_PTR	p_d;
	
/* code */
	
	if (el_ptr->code == GAT)
	{
		if (el_ptr->G.del_type == DEL_IMM)
			p_d = el_ptr->G.delay.del_ptr;
		else
			p_d = set_off_del(el_ptr->G.delay.del_off);
	}
	else
	{
		if (el_ptr->C.del_type == DEL_IMM)
			p_d = el_ptr->C.delay.del_ptr;
		else
			p_d = set_off_del(el_ptr->C.delay.del_off);
	}
	return(p_d);
}


/*************************************************************************

   ROUTINE:     mod_delay

   FUNCTION:    Scan the topological section and set all the delays as
		pointer (ODELAY_PTR)
		The delays expressed in the TIME field are transformed also

   AUTHOR(s):   Daniela Magnani

   DATE:        21/08/1986

   NOTES: 	The elements in the expansion list are not considered because
		they are only constants.

   METHOD: 

**********************************************************************/

mod_delay()
{

/* external functions */

	ODELAY_PTR	set_off_del();
        
/* local variables */

	int		i;
	CONN_PTR	l_conn;

/* code */
        
   for (i = 0; i < U_H->n_top; i++)
   {
      if (U_S[i] != NULL)
      {
        switch(U_S[i]->code)
        {
           case NOD :
           case WIR :
           case REG :
		if (U_S[i]->C.del_type == DEL_CON)
        	  U_S[i]->C.delay.del_ptr = 
			set_off_del(U_S[i]->C.delay.del_off);
                break;
           case GAT :
		if (U_S[i]->G.del_type == DEL_CON)
        	  U_S[i]->G.delay.del_ptr = 
			set_off_del(U_S[i]->G.delay.del_off);
                break;
           case RT_AS :
           case RT_LD :
		if (U_S[i]->A.del_type == DEL_CON)
        	  U_S[i]->A.delay.del_ptr = 
			set_off_del(U_S[i]->A.delay.del_off);
                break;
           case MEM :
		if (U_S[i]->M.del_type == DEL_CON)
        	  U_S[i]->M.delay.del_ptr = 
			set_off_del(U_S[i]->M.delay.del_off);
                break;
	   case RT_CNT :
		/* scan polish in order to find TIME */
		for (l_conn = U_S[i]->O.l_code; l_conn != NULL;
		     l_conn = l_conn->c_next)
		{
		  if (l_conn->type == TIME && l_conn->signal == DEL_CON)
		   l_conn->CT.del_p.del_ptr = 
			set_off_del(l_conn->CT.del_p.del_off);
		}
		break;
	   case AS_TR :
		/* scan polish in order to find TIME */
		for (l_conn = U_S[i]->A.l_code; l_conn != NULL;
		     l_conn = l_conn->c_next)
		{
		  if (l_conn->type == TIME && l_conn->signal == DEL_CON)
		   l_conn->CT.del_p.del_ptr = 
			set_off_del(l_conn->CT.del_p.del_off);
		}
		break;
	   case PROC :
		/* scan polish in order to find TIME */
		for (l_conn = U_S[i]->P.l_code; l_conn != NULL;
		     l_conn = l_conn->c_next)
		{
		  if (l_conn->type == TIME && l_conn->signal == DEL_CON)
		   l_conn->CT.del_p.del_ptr = 
			set_off_del(l_conn->CT.del_p.del_off);
		}
		break;
	   default :
		/* do nothing */
		break;
        }
      }
   }
}


/*************************************************************************

   ROUTINE:     set_off_del

   FUNCTION:    set the delay pointer given the offset

   AUTHOR(s):   Daniela Magnani

   DATE:        31/01/1989

   NOTES: 	The input topological element may only be a carrier or a
		gate

   METHOD: 

**********************************************************************/

ODELAY_PTR set_off_del(del_off)
unsigned long del_off;
{

/* local variables */

	ODELAY_PTR	p_d;
	ODELAY_EXP_PTR	del_exp_tb;
	
/* code */
	
	if (del_off >= u->n_const_del)
	{
		/* scan the delay expansion table in order to
		   find delay */
		for (del_exp_tb = u->del_con_exp_tab;
		     del_exp_tb != NULL && del_exp_tb->n_el != del_off;
		     del_exp_tb = del_exp_tb->next);
		if (del_exp_tb == NULL) bug("search_del");
		p_d = del_exp_tb->st;
	}
	else
		 p_d = (ODELAY_PTR)*(u->del_con_tab + del_off);
	return(p_d);
}


/*************************************************************************

   ROUTINE:     create_new_el_not_con

   FUNCTION:    Map an element not connected with a dummy element at the 
		end of the topological structure.

   AUTHOR(s):   Daniela Magnani

   DATE:        20/03/1989

   NOTES: 	

   METHOD: 

**********************************************************************/

static create_new_el_not_con(el)
int el;
{

/* code */

	U_S[free_el] = U_S[el];
	chng_conn(U_S, el, free_el);
	/* set delete flag for el */
	U_S[free_el]->pt_el = el;
 	U_S[el] = NULL;
        corr[el] = free_el;
	free_el++;
}

