/* LANGUAGE:    C        VAX VMS COMPILER VERSION 2.0-003


 PACKAGE NAME:          LMAIN

 PACKAGE ROUTINES:      main()

 PACKAGE FUNCTION:      linker main

 PACKAGE AUTHOR(s):     Daniela Magnani

 PACKAGE CREATION DATE: 20/08/1986

**********************************************************************/

# include <stdio.h>
# include "ldef.h"
# include "lstruct.h"
/***************************************************************************/
/*                                                                         */
/*                          VARIABLES DECLARATION                          */
/*                                                                         */
/***************************************************************************/

EHEADER         h_exe;
unsigned char   ch_delay = FALSE;
IN_ST		par_des[MAX_DIR];
unsigned long	par_pun[MAX_DIR];
unsigned long   dir_number = 0;
unsigned char   net_flag = FALSE;
unsigned char	atpg_flag = FALSE;
unsigned char	lib_flag = FALSE;



/*************************************************************************

   ROUTINE:     main

   FUNCTION:    #

   AUTHOR(s):   Daniela Magnani

   DATE:        20/08/1986

   NOTES:       27/01/89 (L.Croce): versioning code added.

   METHOD: 

**********************************************************************/

main(argc, argv)
int argc;
char *argv[];

{
/* external functions */

        long    time();
        char    eval_step();
        long    moz_clock();
        
/* local variables */

        long    	cpu;
        long    	i;
	long		j;
	long		ind;
	unsigned char	type;
	unsigned long	ind_name = MAX_UNSIGNED;

/* code */

        /* time initialization */

        cpu = moz_clock(0);

        time(&h_exe.l_ctime);
        date_and_hour(h_exe.l_ctime, &h_exe.l_date, &h_exe.l_time);
        
        init_exe();

        /* control linker options & parameters */

        if (argc < 2) LIN_ER
        for (i = 1; i < argc; i++)
        {
                if (*argv[i] == '-') 
		{
			type = *(argv[i] + 1);
			switch (type = TOLOWER(type))
	                {
        	                case 'z' :
                	                if (strlen(argv[i]) > 2) LIN_ER;
                        	        ch_delay = TRUE;
	                                break;
	
	                        case 'a' :
	                                if (strlen(argv[i]) > 2) LIN_ER;
	                                atpg_flag = TRUE;
	                                break;

	                        case 'd' :
	                                read_param(argv[i]);
	                                if (strlen(argv[i]) > DIRDEF) 
	                                       fatal("Directory name too long");
	                                if (dir_number >= MAX_DIR)
                                        fatal("Too many directories specified");
					par_des[dir_number].type = type;
	                                par_des[dir_number].name = argv[i];
					par_des[dir_number++].lib = NULL;
					break;
	
				case 'h' :
				case 'l' :
				case 'e' :
	                                read_param(argv[i]);
	                                if (strlen(argv[i]) > DIRDEF) 
	                                       fatal("Library name too long");
	                                if (dir_number >= MAX_DIR)
                                        fatal("Too many libraries specified");
					par_des[dir_number].type = type;
	                                par_des[dir_number].name = argv[i];
					par_des[dir_number++].lib = NULL;
					lib_flag = TRUE;
					break;
	
	                        case 'n' :
	                                if (strlen(argv[i]) > 2) LIN_ER;
	                                net_flag = TRUE;
					h_exe.f_drc = TRUE;
	                                break;

 				case 'v' :
					printf("\n%s ver. %s  %s (%s)\n",
					TL_NAME, TL_REL, TL_DATE, TL_CPU);
					exit(MOZ_OK);

	                        default :
	                                printf("\nunknown command switch\n");
	                                LIN_ER;
	                                break;
	                }
	        }
		else
		{
			if (ind_name == MAX_UNSIGNED)
				ind_name = i;
			else
				LIN_ER;
		}
	}

        START;

	if (ind_name == MAX_UNSIGNED) LIN_ER;

        if (strlen(argv[ind_name]) > NAMELENGTH) NAME_ERR(argv[ind_name]);

        printf("\nlinking unit %s\n", argv[ind_name]);

        open_map(argv[ind_name]);

        enqueue_u(argv[ind_name], NULL_NAME);

	/* sort the directories and libraries input structure */
	if (dir_number > 0)
	{
		ind = 0;
		for (j = 0; j < dir_number; j++)
			if (par_des[j].type == DIR) par_pun[ind++] = j;
		if (ind < dir_number)
			for (j = 0; j < dir_number; j++)
				if (par_des[j].type == DIRL) par_pun[ind++] = j;
		if (ind < dir_number)
			for (j = 0; j < dir_number; j++)
				if (par_des[j].type == LIBD) par_pun[ind++] = j;
		if (ind < dir_number)
			for (j = 0; j < dir_number; j++)
				if (par_des[j].type == EXCD) par_pun[ind++] = j;
	}

        /* units link  */
        link_step();

        /* eval & output */
        if (! eval_step()) 
                output_step();
        else
                fatal("linker output not generated");

        close_map();
        
        cpu = moz_clock(cpu);
	printf("\nlink completed :\n");
	printf("\n    %-6d  linked unit(s)", h_exe.n_inst);
	printf("\n    %-6.1f  cpu time (s)\n", (float) cpu / HZ);
        
        STOP;
	exit(MOZ_OK);
}


/*************************************************************************

   ROUTINE:     init_exe

   FUNCTION:    Initialize global structure

   AUTHOR(s):   Daniela Magnani

   DATE:        17/04/1987

   NOTES: 

   METHOD: 

**********************************************************************/

static init_exe()

{
/* code */

        /* global variables initialization */
        h_exe.warn_cnt = 0;
        h_exe.n_pi = 0;
        h_exe.n_bitpi = 0;
        h_exe.n_po = 0;
        h_exe.n_bitpo = 0;
        h_exe.n_pb = 0;
        h_exe.n_bitpb = 0;
        h_exe.n_const = 0;
        h_exe.n_node = 0;
        h_exe.n_wire = 0;
        h_exe.n_bitwire = 0;
        h_exe.n_reg = 0;
        h_exe.n_bitreg = 0;
        h_exe.n_tran = 0;
        h_exe.n_gate = 0;
        h_exe.n_rtas = 0;
        h_exe.n_rtcn = 0;
        h_exe.n_mem = 0;
        h_exe.n_proc = 0;
        h_exe.n_gtar = 0;
        h_exe.n_delay = 0;
        h_exe.max_d = 0;
        h_exe.min_d = 0;
        h_exe.max_cc = 0;
        h_exe.max_fan = 0;
        h_exe.max_atpg_lev = 0;
        h_exe.n_init = 0;
        h_exe.n_modc = 0;
        h_exe.n_func = 0;
        h_exe.vdd = UNDEFINED;
        h_exe.gnd = UNDEFINED;
        h_exe.sb_dim = 0;
        h_exe.n_top = 0;
        h_exe.n_fanin = 0;
        h_exe.n_fanout = 0;
        h_exe.n_conn = 0;
        h_exe.n_nfanin = 0;
        h_exe.n_nfanout = 0;
        h_exe.n_nconn = 0;
        h_exe.n_wfanin = 0;
        h_exe.n_wfanout = 0;
        h_exe.n_rfanin = 0;
        h_exe.n_rfanout = 0;
        h_exe.n_locvar = 0;
        h_exe.n_tfanin = 0;
        h_exe.n_dfanin = 0;
        h_exe.n_pfanout = 0;
        h_exe.n_gfanin = 0;
        h_exe.n_gfanout = 0;
        h_exe.n_asfanin = 0;
        h_exe.n_asfanout = 0;
        h_exe.n_cnfanin = 0;
        h_exe.n_cnfanout = 0;
        h_exe.n_def = 0;
        h_exe.n_inst = 0;

	h_exe.time_unit = 0;

        h_exe.f_sim = TRUE;
        h_exe.f_atpg = TRUE;
        h_exe.f_drc = FALSE;
        h_exe.f_case = FALSE;
        h_exe.max_strength = 0;
        h_exe.max_size = 0;
}


/*************************************************************************

   ROUTINE:     read_param

   FUNCTION:    Read linker parameters

   AUTHOR(s):   Antonio Lioy

   DATE:        17/04/1987

   NOTES: 

   METHOD: 

**********************************************************************/

static read_param (arg)
char *arg;
{
/* local variables */

        char    *p;

/* code */

        for (p = arg, arg += 2; *arg != NULL; p++, arg++) *p = *arg;
        *p = NULL;
}

