/* LANGUAGE:    C        VAX VMS COMPILER VERSION 2.0-003


 PACKAGE NAME:          LSTRUCT.H

 PACKAGE ROUTINES:      #

 PACKAGE FUNCTION:      Global data structures definitions

 PACKAGE AUTHOR(s):     Daniela Magnani

 PACKAGE CREATION DATE: 21/08/1986

**********************************************************************/



typedef struct struct_oheader   *OHEADER_PTR;
typedef struct struct_eheader   EHEADER;
typedef struct struct_odelay    *ODELAY_PTR;
typedef struct struct_odelay_exp *ODELAY_EXP_PTR;
typedef struct struct_hdelay    *HDELAY_PTR;
typedef struct struct_conn      *CONN_PTR;
typedef struct struct_ld_static *STAT_PTR;
typedef struct struct_ev_static *STAT_EV_PTR;
typedef struct struct_carr      DESC_CARR;
typedef struct struct_carr      *CARR_PTR;
typedef struct struct_gate      DESC_GATE;
typedef struct struct_gate      *GATE_PTR;
typedef struct struct_tran      DESC_TRAN;
typedef struct struct_mdef      DESC_DMOD;
typedef struct struct_muse      DESC_UMOD;
typedef struct struct_rtas      DESC_RTAS;
typedef struct struct_rtcn      DESC_RTCN;
typedef struct struct_const     DESC_CONST;
typedef struct struct_mem       DESC_MEM;
typedef struct struct_proc      DESC_PROC;

typedef struct struct_symtab    *SYMT_PTR;
typedef struct struct_unit      *UNIT_PTR;
typedef struct unit_list        *UNITL_PTR;
typedef struct par_unit_table   *PARTAB_PTR;
typedef struct struct_level     *FIFOL_PTR;
typedef struct struct_uname     *FIFOU_PTR;
typedef struct struct_hconst    *HCONST_PTR;
typedef struct fifo             *QUEUE_PTR;
typedef struct interf_struct    *INTF_PTR;
typedef struct interf_inst_struct *INTF_I_PTR;
typedef struct inst_tree_node   *IN_T_PTR;
typedef struct inst_list_struct *IN_L_PTR;
typedef struct node_list_struct *IN_N_PTR;
typedef struct struct_init      *INIT_PTR;
typedef struct aux_stat         *AUX_ST_PTR;
typedef struct db_link		*ST_PTR;
typedef struct c_conn		DESC_CONN;
typedef struct c_call		DESC_CALL;
typedef struct c_time		DESC_TIME;
typedef struct struct_func	*FUNC_PTR;
typedef struct struct_modc	*MODC_PTR;
typedef struct struct_hash_modc	*HMC_PTR;
typedef struct struct_hash_func	*HFC_PTR;
typedef struct in_par_struct	IN_ST;
typedef struct int_gate_struct	*INT_GT_PTR;

typedef struct struct_wconst    DESC_WCONST;
typedef struct struct_dconst    DESC_DCONST;
typedef struct struct_cconst    DESC_CCONST;

/* LIBRARY MANAGEMENT TYPEDEF */
typedef struct struct_index_data	INDEX;
typedef struct struct_index_el		*IND_PTR;
typedef struct struct_index_table	I_TB;
typedef struct struct_lib_header	LIB_H;
typedef struct struct_library		LIB;
typedef struct struct_library		*LIB_PTR;

typedef char				NAME[RFLENGTH + 1];
typedef char				N_IDENT[IDLENGTH + 1];



/********************************************************/

/* HEADER description structures */
/* dimension = 65 bytes */

struct struct_oheader
{
        unsigned long   warn_cnt,
                        n_pi,
                        n_po,
                        n_pb,
                        n_mod,
                        n_umod,
                        n_top,
                        n_inst,         /* global instantiations number */
                        n_sym,          /* number of elements of symb_unit */
                        vdd,
                        gnd;
        long            time_unit;
        long            c_ctime;
        long            *list_def;      /* list of unit definitions indices */
        STAT_PTR        *stat_unit;
        SYMT_PTR        symb_unit,      /* symbol table of internal names */
                        symb_def;       /* symbol table of the units definitions
                                           & instantiations */
        char            unit_type;	/* unit or process or component */
};

/* dimension = 250 bytes */
struct struct_eheader
{
        char            *name;
        unsigned long   warn_cnt,
                        n_pi,
                        n_bitpi,
                        n_po,
                        n_bitpo,
                        n_pb,
                        n_bitpb,
                        n_const,
                        n_node,
                        n_wire,
                        n_bitwire,
                        n_reg,
                        n_bitreg,
                        n_tran,
                        n_gate,
                        n_rtas,
                        n_rtcn,
                        n_mem,
                        n_proc,
                        n_gtar,
                        n_delay,
                        max_d,
                        min_d,
                        max_cc,
                        max_fan,
			max_atpg_lev,
                        n_init,
			n_modc,
			n_func,
                        vdd,
                        gnd,
                        sb_dim,
                        n_top,
                        n_fanin,
                        n_fanout,
                        n_conn,
                        n_nfanin,
                        n_nfanout,
                        n_nconn,
                        n_wfanin,
                        n_wfanout,
                        n_rfanin,
                        n_rfanout,
                        n_locvar,
                        n_tfanin,
                        n_dfanin,
                        n_pfanout,
                        n_gfanin,
                        n_gfanout,
                        n_asfanin,
                        n_asfanout,
                        n_cnfanin,
                        n_cnfanout,
                        n_def,          /* units definitions number */
                        n_inst;         /* units instantiations number */
        long            time_unit;
        long            l_date,
                        l_time,
                        l_ctime;
        STAT_PTR        *p_stat;
	STAT_EV_PTR     *p_ev_stat;
        unsigned char   max_strength,
                        max_size,
                        f_atpg,
                        f_sim,
			f_drc,
			f_case;
};

/* C modules description structure */

/* dimension = 4 bytes */
struct struct_modc
{
	char	*name;
};

/* dimension = 16 bytes */
struct struct_func
{
	unsigned long	func,
			n_par,
			res_dim;
	MODC_PTR	p_mod;
};

/* dimension = 28 bytes */
struct struct_hash_modc
{
	char		*name;
	unsigned long	n_func,
			n_par,
			max_func,
			n_mod;
	HMC_PTR		next,
			insert;
};

/* dimension = 32 bytes */
struct struct_hash_func
{
	char		*name;
	unsigned long	func,
			n_par,
			mod,
			res_dim,
			n_fun;
	HFC_PTR		next,
			insert;
};

/* DELAY description structures */

/* dimension = 12 bytes */
struct struct_odelay
{
        unsigned long   rise,
                        fall;
	long		time_unit;
	unsigned char	rise_type,
			fall_type;
};

/* dimension = 12 bytes */
struct struct_odelay_exp
{
        unsigned long   n_el;
        ODELAY_PTR	st;
        ODELAY_EXP_PTR	next;
};

/* dimension = 20 bytes */
struct struct_hdelay
{
        unsigned long   rise,
                        fall,
                        n_delay;
        HDELAY_PTR      next;
	HDELAY_PTR	insert;
	unsigned char	rise_type,
			fall_type;
};

/* INITIALIZATION table structure */

/* dimension = 16 bytes */
struct struct_init
{
        char            *val;
        unsigned long   n_fanout;
        CONN_PTR        l_fanout;
        INIT_PTR        next;
};

/* VARIABLE PART of the topological descriptor */

/* dimension = 4 bytes */
struct c_conn
{
        short           first,
                        second;
};

/* dimension = 4 bytes */
struct c_call
{
	FUNC_PTR	fun_p;
};

/* dimension = 4 bytes */
struct c_time
{
	union   {
			ODELAY_PTR	del_ptr;
			unsigned long   del_off;
			HDELAY_PTR	delh_ptr;
		} del_p;
};

/* dimension = 13 bytes */
struct struct_conn
{
        CONN_PTR        c_next;
        unsigned long   signal;
        unsigned char   type;
	union   {
			DESC_CONN	conn;
			DESC_CALL	call;
			DESC_TIME	time;
		} conn;
};


/* TOPOLOGICAL DESCRIPTOR */

/* dimension = 16 bytes */
struct aux_stat
{
        unsigned long   n_el;
        STAT_PTR        st;
        STAT_EV_PTR     st_ev;
        AUX_ST_PTR      next;
};

/* la massima dimensione ammessa per gli elementi topologici e' 24.
Elementi piu' grossi devono prevedere puntatore a espansione (PROCESS e
COSTANTE) */

/* dimension = 23 bytes */
struct struct_carr              /* carrier (NODE, WIRE, REGISTER) */
{
        char            *init_el;
	union   {
			ODELAY_PTR	del_ptr;
			unsigned long   del_off;
		} delay;
        CONN_PTR        l_fanout,
                        l_fanin,
                        l_conn;
        unsigned char	dim;
        unsigned char   size,
			del_type;
};

/* dimension = 12 bytes */
struct struct_rtcn              /* rt_condition (RT_CN, RT_CNT) */
{
        CONN_PTR        l_fanout,
                        l_fanin,
                        l_code;
};

/* dimension = 20 bytes */
struct struct_rtas              /* rt_assignement ( RT_AS, RT_LD, BIT_EX. 
                                                    AS_TR ) */
{
	union   {
			ODELAY_PTR	del_ptr;
			unsigned long   del_off;
		} delay;
        CONN_PTR        l_fanout,
                        l_fanin,
                        l_code;
        unsigned char	bit,
			del_type,
                        type;
        unsigned 	str_0 : 4;
        unsigned 	str_1 : 4;
};

/* dimension = 23 bytes */
struct struct_gate              /* gate */
{
        char            *init_el;
	union   {
			ODELAY_PTR	del_ptr;
			unsigned long   del_off;
		} delay;
        CONN_PTR        l_fanout,
                        l_fanin;
	SYMT_PTR	s_lst;		/* pointer to the second name
					   (gate integrated with wire) */
        unsigned char   type,
			del_type;
        unsigned 	str_0 : 4;
        unsigned 	str_1 : 4;
};

/* dimension = 14 bytes */
struct struct_tran              /* transistor */
{
        CONN_PTR        drain,
                        gate,
                        source;
        unsigned char   type,
                        str;
};

/* dimension = 4 bytes */
struct struct_mdef              /* module definition */
{
        CONN_PTR        l_ist;
};

/* dimension = 12 bytes */
struct struct_muse              /* module instantiation */
{
        CONN_PTR        l_fanout,
                        l_fanin,
                        l_fanbin;
};

/* dimension = 8 bytes */
struct struct_wconst             /* constant of wire type */
{
        CONN_PTR        l_fanout,
			l_conn;
};

/* dimension = 16 bytes */
struct struct_dconst             /* constant of int (delay) type */
{
        CONN_PTR        l_fanout,
			l_fanin,
                        l_code;
	long		evval;
};

/* dimension = 4 bytes */
struct struct_cconst             /* constant of char type */
{
        CONN_PTR        l_fanout;
};

/* dimension = 7 + 16 = 23 bytes */
struct struct_const             /* constant */
{
        char            *val;
	unsigned short	leng;
	unsigned char	type;
        union   {
                        DESC_WCONST      d_wconst;
                        DESC_DCONST      d_dconst;
                        DESC_CCONST      d_cconst;
                } desconst;
};

/* dimension = 21 bytes */
struct struct_mem               /* memory */
{
        CONN_PTR        l_fanout,
                        l_fanin;
        char            *val;
	union   {
			ODELAY_PTR	del_ptr;
			unsigned long   del_off;
		} delay;
	unsigned char	word_size,
			addr_size;
        unsigned char   type,
			del_type;
        unsigned 	str_0 : 4;
        unsigned 	str_1 : 4;
};

/* dimension = 25 bytes */
struct struct_proc               /* process */
{
        unsigned long   n_s_code;
        CONN_PTR        l_fanout,
                        l_tfanin,
                        l_dfanin,
                        l_locvar,
                        l_code;
        unsigned char	type;
};

/* dimension = 13 bytes */
struct struct_hconst
{
        char            *val;
        unsigned long   ind;
        HCONST_PTR      next;
	unsigned char	type;
};

/* dimension = 15 + 25 = 40 bytes */
struct struct_ld_static
{
        unsigned long   path_ptr,       /* pointer to instantiations tree */
			pt_el;		/* in order to correctly set path 
					names to gates integrated with wires */
	SYMT_PTR	s_tab;		/* pointer to symbol table */
        unsigned char   attr,
                        code,
			function_flag;
        union   {
                        DESC_CARR       d_carr;
                        DESC_GATE       d_gate;
                        DESC_TRAN       d_tran;
                        DESC_DMOD       d_dmod;
                        DESC_UMOD       d_umod;
                        DESC_RTAS       d_rtas;
                        DESC_RTCN       d_rtcn;
                        DESC_CONST      d_const;
                        DESC_MEM        d_mem;
                        DESC_PROC       d_proc;
			STAT_PTR	free_link;
                } udesc;
};

/* dimension = 38 bytes DEVE essere sempre <= dimensione struct_ld_static */
struct struct_ev_static
{
	HDELAY_PTR	pdelay;
	unsigned long   sim_lev,
                        atpg_lev,
                        comp,
			n_fanout,
			n_fanin,
			n_conn,
			n_code,
                        n_tfanin;
	unsigned char	visited,
			on_path;
};

/* SYMBOL TABLE */

/* dimension = 9 bytes */
struct struct_symtab
{
        unsigned long   st_el;
        char            *el_name;
	char		el_type;
};
        
/* UNIT description structures */

/* dimension = 89 bytes */
struct struct_unit
{
        char            *name;
	unsigned long	n_const_del,
			n_const_del_exp;
	ODELAY_PTR	*del_con_tab;
	ODELAY_EXP_PTR	del_con_exp_tab;
        OHEADER_PTR     head;
        UNIT_PTR        hash_next,
                        level_next;
        UNITL_PTR       son_def_list,
                        father_list;
        long            *pi_table,
                        *po_table,
                        *pb_table;
        long            level;
        INTF_PTR        intf_table;	/* pointer to the starting interface 
					   table's element */
        INTF_PTR        intf_sort_table;/* pointer to the starting interface
					   table's element (sorted by name) */
        PARTAB_PTR      par_table;
        IN_N_PTR        in_lst;
	AUX_ST_PTR	exp_list;
	unsigned long	exp_el;
        unsigned long	dir;         /* index corresponding to directory name */
	unsigned long	n_intf;
        unsigned char   flag_res;
};

/* dimension = 12 bytes */
struct unit_list
{
        char            *name; 
	unsigned long	inst;
        UNITL_PTR       next;
};

/* dimension = 32 bytes */
struct par_unit_table
{
        char            *in_name,
                        *def_name;
        unsigned long   start_index,
			i_node;		/* index in the instantiation tree */
        CONN_PTR	in_param,
                        out_param,
                        bid_param;
        UNIT_PTR        un_addr;
};

/* dimension = 12 bytes */
struct struct_level 
{
        char            *name;
        UNIT_PTR        unit_index;
        FIFOL_PTR       next;
};

/* dimension = 12 bytes */
struct struct_uname 
{
        char            *name,
                        *father_name;
        FIFOU_PTR       next;
};

/* dimension = 8 bytes */
struct fifo
{
        unsigned long   el;
        QUEUE_PTR       pun;
};

/* dimension = 12 bytes */
struct db_link
{
        unsigned long   el;
        ST_PTR		next;
	ST_PTR		prev;
};

/* dimension = 14 bytes */
struct interf_struct	/* interface table model */
{
	INTF_PTR	sort_link;  /* link to the sorted interface table */
        char            *name;
        unsigned long   addr;	/* index of the topological element */
	unsigned short	par_n;	/* number of the parameter */
};

/* dimension = 5 bytes */
struct interf_inst_struct	/* interface table for the instantiation */
{
        unsigned long   addr;	/* index of the topological element */
	unsigned char   f_conn;
};

/* dimension = 40 bytes */
struct inst_tree_node
{
        char            *in_name,
                        *def_name;
        unsigned long   st_addr,
                        end_addr;
	INTF_I_PTR	intf_table;
	UNIT_PTR	un_addr;
        unsigned long	intf_dim,
                        father,
                        child,
                        brother;
};

/* dimension = 16 bytes */
struct inst_list_struct
{
        unsigned long   node,
                        val;
        UNIT_PTR        unit;
        IN_L_PTR        pun;
};

/* dimension = 8 bytes */
struct node_list_struct
{
        unsigned long   node;
        IN_N_PTR        pun;
};

/* dimension = 9 bytes */
struct in_par_struct
{
	char		*name;
	LIB_PTR		lib;
	unsigned char	type;
};

/* dimension = 9 bytes */
struct int_gate_struct
{
	unsigned long	gt;
	INT_GT_PTR	next;
	char		f_gate;
};

/* LIBRARY MANAGEMENT STRUCTURES */

/* structure containing the data of an index record read from file */
struct struct_index_data
{
	long		p_deo;		/* start pointer to the block .deo */
	unsigned long	dim_deo;	/* dimension (bytes) of the block .deo*/
	long		c_time;		/* creation time */
	long		a_time;		/* last access time */
	long		m_time;		/* last modify time */
        N_IDENT		key;		/* unit name */
	unsigned char	val_flag;	/* validity flag (TRUE) */
};

/* structure of a single index element */
struct struct_index_el
{
	IND_PTR		next;		/* pointer to the next element of the 
					   expansion list */
	INDEX		in_d;		/* index data */
};

/* structure of the index table (array + start expansion list) */
struct struct_index_table
{
	unsigned long	array_el;	/* total of array' elements */
	IND_PTR		exp_list;	/* pointer to the start expansion list*/
	IND_PTR		table;		/* index array */
};

/* structure containing the library header read from file */
struct struct_lib_header
{
	unsigned long	cell;		/* index dimension */
	unsigned long	cell_d;		/* amount of index elements deleted */
	long		c_time;		/* library creation time */
	long		a_time;		/* library last access time */
	long		m_time;		/* library last modify time */
	long		rel_num;	/* library release number */
	long		data_type;	/* type of data stored into the 
					   library */
	long		index_pos;	/* index address in the file */
};

/* structure containing all the data characterizing a library */
struct struct_library
{
	char		*name;		/* library name */
	LIB_H		head;		/* library header */
	I_TB		table;		/* library index table */
	long		pos_free;	/* address of the first byte free in
					   the file */
	long		head_pos;	/* address of the header in the file */
	FILE		*f;		/* file descriptor associated to the 
					   library */
	unsigned char	mod_flag;	/* TRUE iff the library has been 
					   modified */
};


