/*

   *************************************************************************
   *      COPYRIGHT IN THIS PROGRAM IS OWNED BY SGS MICROELETTRONICA.      *
   *   IT IS CONFIDENTIAL TO SGS PARTNERS AND IS NOT TO BE DISCLOSED TO    *
   * THIRD PARTIES WITHOUT PRIOR WRITTEN APPROVAL OF SGS MICROELETTRONICA. *
   *************************************************************************

 INCLUDE FILE NAME: portab.h

 PURPOSE:       Definition of portability dependent
                defines in the MOZART system

 CREATION DATE: 11 NOV 1987

 IMPORTANT NOTICE:

                TO OBTAIN THE RIGHT REDEFINITION OF _TOLOWER AND _TOUPPER
                THIS FILE MUST BE INCLUDED AFTER <CTYPE.H>. IN GENERAL
                THIS FILE MUST BE INCLUDED AFTER THE *.H FILES DEFINED
                BY THE SYSTEM.

                In the MOZART simulator source code this file is intended
                to be included in SIMDEF.H and SYMTAB.C files only !

**********************************************************************/

#define M_OK 0
#define M_ER 1
#define M_SY 2
#define M_BU 3
#define M_LI 4

#define MAX_FILENAME_LENGTH 127

#define BSD4_2   1
#define SYSTEM_V 2

#ifdef VAX11C
#define cls() printf( "\33[2J\33[H");
#define LSB_MSB 1
#define ENVIRONMENT "DEC VAX with VMS"
#define UNIX_WA 0
#ifndef HZ
#define HZ 100
#endif
#include <stsdef.h>
#define MSG_OK  STS$M_MSG_NO&(M_OK<<STS$V_MSG_NO)
#define MSG_ERR STS$M_MSG_NO&(M_ER<<STS$V_MSG_NO)
#define MSG_SYS STS$M_MSG_NO&(M_SY<<STS$V_MSG_NO)
#define MSG_BUG STS$M_MSG_NO&(M_BU<<STS$V_MSG_NO)
#define MSG_LIC STS$M_MSG_NO&(M_LI<<STS$V_MSG_NO)
#define VMS_URC STS$M_INHIB_MSG|STS$M_CUST_DEF|STS$M_FAC_SP
#define MOZ_OK  (STS$K_SUCCESS|VMS_URC|MSG_OK)
#define MOZ_ERR (STS$K_SEVERE |VMS_URC|MSG_ERR)
#define MOZ_SYS (STS$K_SEVERE |VMS_URC|MSG_SYS)
#define MOZ_BUG (STS$K_SEVERE |VMS_URC|MSG_BUG)
#define MOZ_LIC (STS$K_SEVERE |VMS_URC|MSG_LIC)
#endif

#ifdef ultrix
#define cls() printf( "\33[2J\33[H");
#define LSB_MSB 1
#define ENVIRONMENT "DEC VAX with ULTRIX"
#define UNIX_WA BSD4_2
#ifndef HZ
#define HZ 60
#endif
#ifdef _tolower
#undef _tolower
#endif
#define _tolower(c)     ((c) >= 'A' && (c) <= 'Z' ? (c) | 0x20:(c))
#ifdef _toupper
#undef _toupper
#endif
#define _toupper(c)     ((c) >= 'a' && (c) <= 'z' ? (c) & 0x5F:(c))
#endif

#ifdef eunice
#define cls()  printf( "\33[2J\33[H");
#define LSB_MSB 1
#define ENVIRONMENT "DEC VAX with EUNICE"
#define UNIX_WA BSD4_2
#endif

#ifdef IBMRT
#define cls() printf( "\33H\33J");
#define LSB_MSB 0
#define ENVIRONMENT "IBM RT with AIX"
#define UNIX_WA SYSTEM_V
#endif

#ifdef IBMAT
#define cls() printf( "\33H\33J");
#define LSB_MSB 1
#define ENVIRONMENT "IBM PC AT with MS/DOS"
#define UNIX_WA 0
#endif

#ifdef IBMVMCMS
#define cls() printf( "\33H\33J");
#define LSB_MSB 0
#define ENVIRONMENT "IBM VM/CMS"
#define UNIX_WA 0
#endif

#ifdef HPUX
#define cls() printf( "\33H\33J");
#define LSB_MSB 0
#define ENVIRONMENT "HP 9000 with HP-UX"
#define UNIX_WA SYSTEM_V
#include <sys/param.h>
#ifdef DELAY
#undef DELAY
#endif
#ifndef HZ
#define HZ 50
#endif
#ifdef _tolower
#undef _tolower
#endif
#define _tolower(c)     ((c) >= 'A' && (c) <= 'Z' ? (c) | 0x20:(c))
#ifdef _toupper
#undef _toupper
#endif
#define _toupper(c)     ((c) >= 'a' && (c) <= 'z' ? (c) & 0x5F:(c))
#endif

#ifdef ATT3B1
#define cls() printf( "\33H\33J");
#define LSB_MSB 0
#define ENVIRONMENT "AT&T 3B1 with UNIX"
#define UNIX_WA SYSTEM_V
#ifndef HZ
#define HZ 60
#endif
#ifdef _tolower
#undef _tolower
#endif
#define _tolower(c)     ((c) >= 'A' && (c) <= 'Z' ? (c) | 0x20:(c))
#ifdef _toupper
#undef _toupper
#endif
#define _toupper(c)     ((c) >= 'a' && (c) <= 'z' ? (c) & 0x5F:(c))
#endif

#ifdef SUN
#define cls() printf( "\33H\33J");
#define LSB_MSB 0
#define ENVIRONMENT "SUN with UNIX"
#define UNIX_WA BSD4_2
#ifndef HZ
#define HZ 60
#endif
#ifdef _tolower
#undef _tolower
#endif
#define _tolower(c)     ((c) >= 'A' && (c) <= 'Z' ? (c) | 0x20:(c))
#ifdef _toupper
#undef _toupper
#endif
#define _toupper(c)     ((c) >= 'a' && (c) <= 'z' ? (c) & 0x5F:(c))
#endif

#ifdef APOLLO
#define cls() printf( "\33H\33J");
#define LSB_MSB 0
#define ENVIRONMENT "APOLLO DOMAIN"
#define UNIX_WA BSD4_2
#ifdef _tolower
#undef _tolower
#endif
#define _tolower(c)     ((c) >= 'A' && (c) <= 'Z' ? (c) | 0x20:(c))
#ifdef _toupper
#undef _toupper
#endif
#define _toupper(c)     ((c) >= 'a' && (c) <= 'z' ? (c) & 0x5F:(c))
#endif

#if (UNIX_WA)
#define MOZ_OK  M_OK
#define MOZ_ERR M_ER
#define MOZ_SYS M_SY
#define MOZ_BUG M_BU
#define MOZ_LIC M_LI
#endif
